/* =============================================================
   The functions required for the q-\bar{q} initial-state 
   NNLO contributions to the DY rapidity distributions.
   ============================================================= */

#include "hardfns.hh"
#include "qiqjfns.hh"
#include "BornNLOfns.hh"

using namespace BornNLO;

double qbarq_no_NF_1(double y, double z){
  double u,t,r,Z2,z2,z3,z4,z5,z6,z7,z8,z9,omz2,
        u2,u3,u4,u5,u6,u7,u8,u9,u10,u11,u12,up12,up13,omu3,omu4,temp;
 u = (z+y*(1.-z))/(1.-y*(1.-z));   t = sqrt(z);   r = sqrt(u);
 Z2 = PISQ6;
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;  z5 = z3*z2;
 z6 = z3*z3;  z7 = z4*z3;  z8 = z4*z4;  z9 = z5*z4;
 u2 = u*u;  u3 = u2*u;  u4 = u2*u2;  u5 = u3*u2;
 u6 = u3*u3;  u7 = u4*u3;  u8 = u4*u4;  u9 = u5*u4;
 u10 = u5*u5;  u11 = u6*u5;  u12 = u6*u6;
 up12 = (1.+u)*(1.+u);   up13 = up12*(1.+u);  
 omz2 = (1.-z)*(1.-z);   omu3 = (1.-u)*(1.-u)*(1.-u);  omu4 = omu3*(1.-u);
 temp =
// q^2 terms: 
// J's:
- 4./9. * (1-z)*(2*u3*z3-16*u*z-6*z+6*u*z2+3*z2+5*u2*z2+12) * J2(y,z)
- 4./3. * (1-z)*(z2+2*z+4) * J3(y,z)
- 4./9. * z2 * (1-z)/u2/(u-z)/(z*up12-4*u2)/(z*up12-4*u2) * ( 
  -240*u7-3*z5-16*u3*z2+114*u3*z3+24*u2*z3-4*u5*z5+136*u5*z
  -424*u5*z2+8*u7*z+600*u6*z+54*u5*z4-2*u*z4+36*u4*z3+66*z4*u3
  +22*u6*z4+72*u7*z2-108*u6*z3-16*z5*u3+76*z4*u4-22*u7*z3
  -9*z5*u4+2*u7*z4-u6*z5-16*u6*z2-68*u5*z3+22*z4*u2-12*z5*u
  -19*z5*u2-272*u4*z2 ) 
    * ( J21(y,z) 
      - (1+z) * (1-u*z)/(1+u)/r/(r+t)/(1+t*r)/omz2
        * log(z) * log((1+z)/2)
      + 1./z/(1+u) * ( log((r+t)/(1+u)) + 2.*u/(1-u) * log(z) 
		      - 1./2. * (1+u)/(1-u) * (1+t/r) * log(u) ) )
// polylog's
+ 4./9. * z * u*(1-z)*(z+1)/(u-z)/(1-u*z)/up12 
   * (8*z2+9*u2*z2+16*z+18*u2*z+7-2*u+8*u2)
    * li2((1-u*z)/(1+u))
+ 32./9. * t*r * z*(1-z)*(1+u)*(u+z)*(1+u*z)/u/(u-z)/(1-u*z)
   * ( - li2(t*r) + li2(-t*r) - li2((1-t*r)/2)
       - 1./2. * li2((1-t*r)/(1+u))
       - 1./4. * log(1+t*r)*log(1+t*r) + 1./4. * log(1-t*r)*log(1-t*r) 
       + 1./2. * log(1+t*r) * ( log(z) + log(1+u) - log(1-t*r) )
       + 1./2. * log(1-t*r) * ( - log(z) - 3./4. * log(u) + 1./2. * log(r-t)
                             - log(r+t) + 2. * log(2.) )
       - 1./4. * (log(1+u)-log(u)) * log(1+u) + 5./4. * Z2 )
- 2./9. * (1-z)*(-12*u6+12*u4+50*u2*z2+66*z4-102*z3*u+94*u3*z2
-11*u3*z3-166*u2*z3+54*u5*z5+u8*z4-3*u9*z3+54*u5*z+80*u5*z2
+86*u7*z+2*u7*z5+2*u10*z4-26*u6*z-154*u5*z4+108*u*z4-84*u4*z3
-6*u8*z3-3*u8*z2+70*z4*u3-72*u4*z-126*u6*z4+172*u7*z2
-78*u6*z3+12*z5*u3-159*z4*u4+211*u7*z3-2*u9*z5+96*z5*u4
+62*u7*z4+12*u6*z5-210*u6*z2+207*u5*z3+90*z4*u2-66*z5*u
-108*z5*u2-26*u3*z-127*u4*z2)/u3/(1-u*z)/up12/(1-u)/(u-z)
    * ( li2(t*r) - Z2 )
+ 2./9.*(1-z)*(-38*u*z+36*u2+96*u3+60*u4-128*u2*z+22*u*z2+139*u2*z2
+2*z2-9*z3*u+196*u3*z2-113*u3*z3-40*u2*z3+94*u5*z5+108*u8*z4
-114*u5*z-28*u5*z2-108*u7*z5-12*u6*z-90*u5*z4+82*u4*z3
-102*u8*z3-32*z4*u3-154*u4*z+43*u6*z4+48*u7*z2-14*u6*z3
+14*z5*u3-44*z4*u4-137*u7*z3+66*u9*z4+54*z5*u4+90*u7*z4
+12*u6*z5-66*u8*z5+45*u6*z2-19*u5*z3-5*z4*u2-210*u3*z
+256*u4*z2)/u/(1-u*z)/up12/(1-u)/(u-z)
    * li2(-t*r)
+ 2./9. * (1-z) * (14*u*z-12*u2-48*u3-36*u4+76*u2*z-10*u*z2+19*u2*z2
-2*z2+3*z3*u-152*u3*z2-19*u3*z3+66*u2*z3+2*u5*z5+2*u8*z4
+44*u5*z-150*u5*z2-2*u7*z5-48*u5*z4+124*u4*z3+8*z4*u3+104*u4*z
-17*u6*z4+30*u6*z3+16*z4*u4+15*u7*z3-57*u6*z2+5*u5*z3
+31*z4*u2+50*u3*z-56*u4*z2)/(1-u)/u/(1-u*z)/(u-z)/up12
  * li2((1-t*r)/2)
+ 2./9. * z *(1-z) * (-31*u6-7*u7+13*u8+14*u3+42*u4+u5-50*u2*z
+102*u*z2+166*u2*z2-66*z3-108*z3*u+16*u3*z2-70*u3*z3-90*u2*z3
+73*u5*z-107*u5*z2-20*u7*z-13*u9*z-11*u8*z+22*u6*z-54*u5*z4
+2*u9*z2+66*u*z4+104*u4*z3-2*u8*z3+19*u8*z2-12*z4*u3+47*u4*z
-12*u6*z4-37*u7*z2+62*u6*z3-96*z4*u4-14*u7*z3-101*u6*z2
+184*u5*z3+108*z4*u2-80*u3*z-60*u4*z2)
/u3/(1-u*z)/up12/(1-u)/(u-z)
   * ( li2((1-t*r)/(1+u)) + 1./2. * Z2 )
+ 2./9.*(1-z)*(1+u)*( 5*u4*z3-22*u3*z2+12*u3*z-5*z4*u3-12*u2
+18*u2*z3-3*u2*z2+8*u2*z+9*z4*u2-22*u*z2+12*u*z-5*u*z4+5*z3 )
/u/(1-u)/(u-z)/(1-u*z)
   * li2((1-u)/(1+t*r))
// ln's
- 16./3. * (1+2*z+z2+z3)*(1-z)*(1+u)/(1+z)/(1-u*z)
   * ( - log(1.-z)*log(1.-z) + 2*log(1-z) * (log(1+u) - log(1-u*z)) 
       - log(1+t) * log(u) )
- 1./9.*(1-z)*(-14*z3-13*z2-z4+48*u+85*u*z+36*u3+120*u2-72*u4-36*u5
-86*u6*z5+113*u2*z-4*u8*z4-260*u3*z3+92*u*z2+213*u2*z2-206*u3*z2
+162*u2*z3-2*u5*z5+2*u5*z+22*u5*z2+48*u6*z-72*u5*z4+62*u*z4+48*u4*z3
-166*z4*u3-55*u6*z4-48*u7*z2-22*u6*z3+63*z5*u3+45*z4*u4+120*u7*z3
+181*z5*u4+78*u7*z4-41*u6*z2-36*u5*z3+107*z4*u2+z5*u+21*z5*u2-43*u4*z2
+68*z3*u+16*u7*z5+102*u8*z3-257*u4*z-66*u9*z5-247*u3*z-66*u9*z4-40*u8*z5
-54*u4*z6-12*u6*z6-94*u5*z6+66*u8*z6-12*z6*u3+106*u7*z6)
/u/(1-u*z)/(u-z)/up12/(1-u)/(z+1)
   * log(1+t*r)*log(1+t*r)
+ 1./9.*(-12*u*z+36*u2+96*u3+60*u4-90*u2*z+8*u*z2+315*u2*z2-24*z2
+24*z4-59*z3*u+244*u3*z2-237*u3*z3-88*u2*z3-620*u4*z6+325*u5*z5
-326*u8*z4-70*u5*z-118*u5*z2+187*u6*z6-151*u7*z5+36*u6*z-104*u5*z4
-326*u7*z7+36*u6*z7+198*u9*z6-8*u*z4+104*u4*z3+306*u8*z3-290*u5*z6
+326*u8*z6+162*u4*z7+280*z4*u3-108*z6*u3+36*z7*u3-144*u4*z-182*u6*z4
-144*u7*z2-38*u6*z3+513*z5*u3-19*z6*u2+12*z4*u4+477*u7*z3-198*u8*z7
-198*u9*z4+290*u5*z7+390*z5*u4-126*u7*z4-34*u6*z5+270*u7*z6-108*u8*z5
-261*u6*z2-289*u5*z3-76*z4*u2-185*z5*u-334*z5*u2-312*u3*z+548*u4*z2)
/u/(1-u*z)/(u-z)/up12/(1-u)/(z+1)
    * log(1+t*r) * log(z) 
-4./9.*z*(8*z5*u+9*z5*u3+11*z4*u3-24*u*z4-48*z4*u2-16*z4+16*u4*z3+65*u3*z3
+46*u2*z3+31*z3*u-65*u*z2-50*u2*z2-35*u3*z2-16*z2+16*u4*z-7*u*z+22*u3*z
+50*u2*z+2*u2-7*u-8*u3)/(u-z)/(1-u*z)/(z+1)/up12
    * log(1+t*r) * log(1+z)
- 4./9. * (2*u3*z3+2*z3*u-9*u2*z3-2*z2-2*u4*z2+7*u3*z-11*u2*z
     +7*u*z+6*u2)*z*(1-z)*(1+u)/u/(1-u*z)/(1-u)/(u-z)
   * log(1+t*r) * log(1+t)
- 2./9. * (1-z) * (-96*u-147*u*z-252*u2+48*u6-96*u3+204*u4+192*u5
-311*u2*z-94*u*z2-236*u2*z2+15*z3+15*z2-59*z3*u+217*u3*z2+344*u3*z3
-148*u2*z3+54*u4*z6+16*u5*z5+4*u8*z4+96*u5*z-19*u5*z2+12*u6*z6
-16*u7*z5-12*u6*z+71*u5*z4-64*u*z4-8*u4*z3-102*u8*z3+94*u5*z6
-66*u8*z6+160*z4*u3+12*z6*u3+269*u4*z+55*u6*z4+48*u7*z2+31*u6*z3
-28*z5*u3-85*z4*u4-123*u7*z3+66*u9*z5+66*u9*z4-156*z5*u4-81*u7*z4
+89*u6*z5-106*u7*z6+40*u8*z5+41*u6*z2+82*u5*z3-126*z4*u2-11*z5*u2
+73*u3*z+28*u4*z2)/u/(1-u*z)/(u-z)/up12/(1-u)/(z+1)
   * log(1+t*r) * log(1+u)
+ 1./9. * (1-z) * (-96*u+10*u*z-300*u2+96*u6-120*u3+300*u4+312*u5
-84*u2*z+16*u*z2+75*u2*z2-6*z3+2*z2-9*z3*u+172*u3*z2-123*u3*z3
+38*u2*z3-98*u5*z5-112*u8*z4-198*u5*z+150*u5*z2+112*u7*z5
-12*u6*z+104*u5*z4+6*u*z4-228*u4*z3+102*u8*z3+92*z4*u3-226*u4*z
-23*u6*z4-48*u7*z2-16*u6*z3-14*z5*u3+158*z4*u4+121*u7*z3
-66*u9*z4-54*z5*u4-90*u7*z4-12*u6*z5+66*u8*z5+59*u6*z2
-231*u5*z3+67*z4*u2-178*u3*z+286*u4*z2)
/u/(1-u)/up12/(1-u*z)/(u-z)
   * log(1+t*r) * log(u)
-4./9./u *( 13*u*z-12*u2-24*u3-12*u4+41*u2*z-8*u*z2+3*u2*z2-z2+z4+5*z3*u
-46*u3*z2-29*u3*z3+22*u2*z3-6*u5*z5-4*u5*z-12*u5*z2+12*u5*z4+8*u*z4
-68*u4*z3+70*z4*u3+25*u4*z+6*u6*z4+8*z5*u3+2*z4*u4-21*z5*u4-6*u6*z2
-22*u5*z3+9*z4*u2+14*z5*u+z5*u2+21*u3*z+10*u4*z2)/up12/(z+1)/(1-u)/(u-z) 
   * log(1+t*r) * log(2.)
- 2./9. * (1-z) * (48*u+109*u*z+144*u2+144*u3+48*u4+260*u2*z+89*u*z2
+284*u2*z2-13*z3-13*z2+47*z3*u+89*u3*z2-135*u3*z3+162*u2*z3
-66*u4*z6+172*u5*z5+66*u8*z4-60*u5*z+64*u5*z2-174*u6*z6
+108*u7*z5+50*u5*z4+67*u*z4-135*u4*z3-162*u5*z6+65*z4*u3
-12*z6*u3-78*u4*z-4*u6*z4-220*u6*z3+32*z5*u3+128*z4*u4
-102*u7*z3+182*z5*u4+72*u7*z4+90*u6*z5-66*u7*z6+66*u8*z5
+48*u6*z2-208*u5*z3+192*z4*u2+6*z5*u2+101*u3*z+51*u4*z2)
/u/(u-z)/(z+1)/(1-u*z)/up12
   * log(1+t*r) * log(1-t*r)
+ 8./9. * (1-z) * (-6-12*z-18*u-27*u*z-18*u2-6*u3-16*u2*z-18*u*z2
-12*u2*z2-4*z3-11*z2-5*z4+6*z3*u+18*u3*z2+30*u3*z3+8*u2*z3
-6*u*z4+8*u4*z3+6*z4*u3+6*u4*z+3*z5*u3+z4*u4-12*z4*u2
+3*z5*u+2*z5*u2+9*u3*z+7*u4*z2)/(-1+u*z)/(z-u)/(z+1)/up12
   * log(1-t*r) * log(1-t*r)
+ 1./9.*(14*u*z-12*u2+12*u4+12*u2*z-26*u*z2+123*u2*z2-2*z2+2*z4
-127*z3*u+176*u3*z2-97*u3*z3-208*u2*z3-228*u4*z6+189*u5*z5
-110*u8*z4-26*u5*z-256*u5*z2+71*u6*z6-59*u7*z5+12*u6*z
-174*u5*z4-110*u7*z7+12*u6*z7+66*u9*z6+26*u*z4+196*u4*z3+102*u8*z3
-82*u5*z6+110*u8*z6+54*u4*z7+388*z4*u3-52*z6*u3+12*z7*u3+10*u4*z
-162*u6*z4-48*u7*z2+18*u6*z3+123*z5*u3-15*z6*u2+74*z4*u4+169*u7*z3
-66*u8*z7-66*u9*z4+98*u5*z7+252*z5*u4-42*u7*z4-42*u6*z5+90*u7*z6
-36*u8*z5-165*u6*z2-5*u5*z3+160*z4*u2-143*z5*u-316*z5*u2-38*u3*z
+142*u4*z2)/u/(1-u*z)/(u-z)/up12/(1-u)/(z+1)
    * log(1-t*r) * log(z)
-4./9.*z*(8*z5*u+9*z5*u3+11*z4*u3-24*u*z4-48*z4*u2-16*z4+16*u4*z3
+65*u3*z3+46*u2*z3+31*z3*u-65*u*z2-50*u2*z2-35*u3*z2-16*z2+16*u4*z
-7*u*z+22*u3*z+50*u2*z+2*u2-7*u-8*u3)/(u-z)/(1-u*z)/(z+1)/up12
    * log(1-t*r) * log(1+z) 
+ 1./9. * (1-z) * (84*u6+144*u7+48*u8-48*u3-132*u4-96*u5-50*u2*z2
-66*z4+102*z3*u-74*u3*z2+13*u3*z3+166*u2*z3-42*u5*z5+59*u8*z4
-157*u9*z3-49*u5*z-47*u5*z2-35*u7*z+98*u7*z5-102*u10*z3
+110*u10*z4+u8*z-66*u10*z5+66*u11*z4-u6*z+128*u5*z4
+35*u9*z2-108*u*z4+64*u4*z3+29*u8*z3+38*u8*z2-70*z4*u3
+66*u4*z-78*u6*z4-164*u7*z2+81*u6*z3-12*z5*u3+159*z4*u4
-26*u7*z3-110*u9*z5+90*u9*z4-96*z5*u4-160*u7*z4+42*u6*z5
+12*u8*z5+34*u6*z2-138*u5*z3-90*z4*u2+66*z5*u+108*z5*u2
+2*u3*z+172*u4*z2)/u3/(1-u*z)/up12/(1-u)/(u-z)
   * log(1-t*r) * log(u)
+ 2./9.*(1-z)*(240*u6+48*u7+96*u3+348*u4+444*u5+35*u2*z2+66*z4+66*z5
-102*z3*u+195*u3*z2-110*u3*z3-233*u2*z3-66*u4*z6+73*u5*z5-9*u8*z4
-102*u9*z3+328*u5*z+51*u5*z2+u7*z-66*u6*z6+177*u7*z5+66*u10*z4+66*u10*z5
+90*u6*z-41*u5*z4-66*u9*z6+72*u*z4+51*u4*z3-236*u8*z3-24*u5*z6-172*u8*z6
+35*u8*z2+114*z4*u3-162*z6*u3+402*u4*z+83*u6*z4-66*z6*u+78*u7*z2
-172*u6*z3+172*z5*u3-174*z6*u2+196*z4*u4-197*u7*z3+106*u9*z5+70*u9*z4
+175*z5*u4+63*u7*z4+179*u6*z5-160*u7*z6+90*u8*z5+32*u6*z2-259*u5*z3
-4*z4*u2+108*z5*u+90*z5*u2+133*u3*z+342*u4*z2)/(z+1)/up12/(u-z)/(1-u*z)/u3
    * log(1-t*r) * log(1+u)
+ 2./9. * (1-z) * (-192*u6-48*u7-48*u3-192*u4-288*u5-48*u2*z2-66*z4
+102*z3*u-124*u3*z2+284*u3*z3+268*u2*z3+12*u5*z5+43*u5*z
+12*u5*z2-13*u7*z-20*u6*z-44*u5*z4-174*u*z4+168*u4*z3+13*u8*z2
-334*z4*u3+30*u4*z-6*u6*z4+20*u7*z2-42*u6*z3+162*z5*u3
-248*z4*u4-19*u7*z3+66*z5*u4-24*u6*z2+123*u5*z3-264*z4*u2
+66*z5*u+174*z5*u2+12*u3*z-129*u4*z2)
/up12/(u-z)/(1-u*z)/u3
    * log(1-t*r) * log(r+t)
- 2./9. * (2*u4*z6-2*z4*u4-3*u3*z3+3*z5*u3-6*u2*z3+6*z5*u2
-41*z2-11*u2*z2+25*z3*u-53*z4*u2-52*u*z2+3*z5*u-6*z-28*u*z
-76*u*z4+12-35*z4+6*z3)/(1-u*z)/(z+1)/(1+u)
    * log(1-t*r) * log(2.)
// manifestly symmetric; just divided by 2, so far:
+ 1./9.*z*(1-z)*(-2*z3*u-2*u3*z3-13*u2*z3+2*u4*z2-28*u2*z2-10*u3*
z2+2*z2-10*u*z2+13*u2*z+7*u3*z+7*u*z-6*u2)/(u-z)/u/(1-u*z)
    * ( li2(z) + log(z) * log(1-z) )
+ 2./9.*z*(1-z)*(-17*u3*z3-17*z3*u+7*u4*z2-23*u*z2-23*u3*z2
+42*u2*z2+7*z2-77*u*z-7*z-7*u4*z-77*u3*z-38*u2*z+4*u2
-15*u-15*u3)/(1-u*z)/(u-z)/up12
    * ( li2(-z) + log(z) * log(1+z) )
-2./9.*(1-z)*(1+u)*z*(2*u4*z2-2*u3*z3-7*u3*z-6*u2+9*u2*z3+11*u2*z-2*z3*u
-7*u*z+2*z2)/(u-z)/(1-u)/(1-u*z)/u
   * ( li2(-r*(t-1)/(r+1)) - li2((r-1)/(r+t))
     + li2(-(r-1)/(1+t*r)) - li2(-(t-1)/(r+1)) )
+ 1./9.*(1-z)*(1+u)*(-12*u4-24*u2*z2-33*z4+51*z3*u+47*u3*z2+112*u3*z3
-84*u2*z3+33*u5*z5-33*u8*z4+18*u5*z+47*u5*z2+33*u7*z5+124*u5*z4+46*u*z4
-134*u4*z3+124*z4*u3-84*u6*z4-84*u6*z3+33*z5*u3-112*z4*u4+51*u7*z3
-40*z5*u4+46*u7*z4-46*u6*z5-24*u6*z2+112*u5*z3-84*z4*u2+33*z5*u-46*z5*u2
+18*u3*z-88*u4*z2)/(u-z)/(1-u)/(1-u*z)/u3
   * ( li2(-u) - li2(-1./u) )
// sym^2
-1./36.*(-1+z)*(2*u4*z3+5*u3*z2-2*u3*z3+4*u2*z2-22*u2*z+12*u2+2*u2*z3
  +5*u*z2-2*z3*u+2*z3)/u2
   * ( li2((1-u)/(1+u)) - li2((1-u)/2) 
     + li2(-(1-u)/(1+u)) - li2(-(1-u)/2/u)
     - (2*log(abs(1-u)) - log(u)) * (2*log((1+u)/2) - log(u)) )
// asym^2
- 1./36.*(-1+z)/u2*(12*u3+168*u4+12*u5-12*u2*z+105*u2*z2-6*z4
-21*z3*u+74*u3*z2-111*u3*z3-24*u2*z3-6*u8*z4-254*u5*z
+74*u5*z2+6*u7*z5-12*u6*z+24*u5*z4+6*u*z4-72*u4*z3+24*z4*u3
-76*u4*z+21*u6*z4-24*u6*z3+6*z4*u4-21*u7*z3+6*u7*z4
-6*u6*z5+105*u6*z2-111*u5*z3+21*z4*u2+6*z5*u-6*z5*u2
-254*u3*z+346*u4*z2)/(1-u)/(1+u)/(u-z)/(1-u*z)
   * ( li2((1-u)/(1+u)) + li2((1-u)/2) 
     - li2(-(1-u)/(1+u)) - li2(-(1-u)/2/u) )
- 1./36. * (1-z) * (-12*u6-36*u7-36*u3-12*u4+48*u5+144*u2*z
-306*u*z2-615*u2*z2+198*z3+198*z4+224*z3*u-524*u3*z2+494*u3*z3
+41*u2*z3-76*u5*z5+270*u8*z4+224*u9*z3+672*u5*z-402*u5*z2+297*u7*z
-494*u7*z5+198*u10*z3+198*u10*z4+144*u8*z+471*u6*z+180*u5*z4
-306*u9*z2+332*u*z4+1216*u4*z3+41*u8*z3-615*u8*z2+465*z4*u3
+471*u4*z+401*u6*z4-524*u7*z2+1216*u6*z3-494*z5*u3+401*z4*u4
+494*u7*z3-198*u9*z5+332*u9*z4-200*z5*u4+465*u7*z4-200*u6*z5
-530*u8*z5-470*u6*z2+1582*u5*z3+270*z4*u2-198*z5*u-530*z5*u2
+297*u3*z-470*u4*z2)*z/u3/up12/(1-u*z)/(u-z)/(z+1) 
    * log(z)*log(z)
+ 2./9.*z2*(1-z)*(33+47*z2)*up12/(z+1)/(1-u*z)/(u-z) * log(z) * log(1-z)
+ 32./9.*z2*up12*(z2+1)*(1-z)/(1+z)/(u-z)/(1-u*z)
  * (log(z)-log(1-z)) * log((1+z)/2)
// sym^2
- 2./9. * z * (-16*z+15*u-15*u*z-4*u2+15*u3-100*u2*z+100*u*z2
+100*u2*z2-16*z3+16*z2+16*z4-96*z3*u+100*u3*z2-96*u3*z3
-92*u2*z3+13*u*z4-16*u4*z3+13*z4*u3-16*u4*z-17*z5*u3
+16*z4*u4+96*z4*u2-17*z5*u-15*u3*z+16*u4*z2)
/(1-u*z)/(u-z)/(z+1)/up12
  * log(1+z) * (log(1+u) - 1./2.*log(u))
// asym^2
- 1./9. * z * (1-u)/(1+u)/(u-z)/(1-u*z)
 * (16*u2*z3+16*u2*z+u*z4+34*z3*u-u+30*u*z+16*z3+16*z)
  * log(1+z) * log(u)
// sym^2
-1./9.*(1-z)*z*(-14*u6-11*u7-11*u3-14*u4-70*u5+83*u2*z-204*u*z2
-428*u2*z2+132*z3+132*z4+145*z3*u-319*u3*z2+224*u3*z3+18*u2*z3
-50*u5*z5+180*u8*z4+145*u9*z3+206*u5*z-328*u5*z2+218*u7*z
-325*u7*z5+132*u10*z3+132*u10*z4+83*u8*z+366*u6*z+154*u5*z4
-204*u9*z2+217*u*z4+531*u4*z3+18*u8*z3-428*u8*z2+319*z4*u3
+366*u4*z+333*u6*z4-319*u7*z2+531*u6*z3-325*z5*u3+333*z4*u4
+224*u7*z3-132*u9*z5+217*u9*z4-133*z5*u4+319*u7*z4-133*u6*z5
-349*u8*z5-67*u6*z2+368*u5*z3+180*z4*u2-132*z5*u-349*z5*u2
+218*u3*z-67*u4*z2)/u3/(1-u*z)/(u-z)/(z+1)/up12
    * log(z) * (log(1+u) - 1./2.*log(u))
// asym^2
-1./18.*z*(1-u)*(1+u)*(25*u3-61*u2*z+102*u*z2+109*u2*z2-66*z3+66*z4
-143*z3*u+183*u3*z2-358*u3*z3-229*u2*z3-66*u5*z5+102*u5*z2
+107*u5*z4+107*u*z4-229*u4*z3+168*z4*u3-61*u4*z+66*u6*z4
-66*u6*z3-79*z5*u3+222*z4*u4-41*z5*u4-143*u5*z3+222*z4*u2
-66*z5*u-41*z5*u2-67*u3*z+109*u4*z2)/(u-z)/(1-u*z)/u3
    * log(z) * log(u)
// asym^2
-1./9.*(-2*z4*u3+9*z4*u2-2*u*z4+2*z3+48*u2*z3+2*u4*z3-24*u3*z3
-24*z3*u-31*u*z2-31*u3*z2+59*u2*z2-48*u*z-48*u3*z+90*u2*z-24*u
+48*u2-24*u3)*(1+u)*(1-z)/u/(1-u)/(u-z)/(1-u*z)
    * log(1+t) * log(u)
// sym^2
- 1./36. * (1-z) * (1164*u6+288*u7+288*u3+1164*u4+1752*u5+66*u2*z2
+132*z4+132*z5-204*z3*u+321*u3*z2-315*u3*z3-477*u2*z3
-132*u4*z6+138*u5*z5-17*u8*z4-204*u9*z3+1536*u5*z+406*u5*z2
+282*u7*z-132*u6*z6+353*u7*z5+132*u10*z4+132*u10*z5+1058*u6*z
+174*u5*z4-132*u9*z6+142*u*z4-265*u4*z3-477*u8*z3-48*u5*z6
-346*u8*z6+66*u8*z2+225*z4*u3-322*z6*u3+1058*u4*z+371*u6*z4
-132*z6*u+321*u7*z2-265*u6*z3+353*z5*u3-346*z6*u2+371*z4*u4
-315*u7*z3+214*u9*z5+142*u9*z4+332*z5*u4+225*u7*z4+332*u6*z5
-322*u7*z6+180*u8*z5+490*u6*z2-542*u5*z3-17*z4*u2+214*z5*u
+180*z5*u2+282*u3*z+490*u4*z2)/u3/up12/(1-u*z)/(u-z)/(z+1)
  * (log(1+u)-1./2.*log(u)) * (log(1+u)-1./2.*log(u))
// sym^2
+ 1./18.*(-12*u3+12*u2*z-79*u2*z2+2*z4+2*z5+3*z3*u-122*u3*z2
+14*u3*z3-21*u2*z3+2*u4*z6-4*u5*z5+u5*z4+u*z4-21*u4*z3
-2*u5*z6-106*z4*u3-2*z6*u3+12*u4*z+2*u6*z4-2*z6*u-10*z5*u3
+2*z6*u2-59*z4*u4+z5*u4+2*u6*z5+3*u5*z3-59*z4*u2-4*z5*u
+z5*u2+10*u3*z-79*u4*z2)*(1-z)/(u-z)/(1-u*z)/u2/(z+1)
  * log(2.) * (log(1+u)-1./2.*log(u))
// asym^2
+ 1./36.*(1-z)*(-60*u6-96*u7-96*u3-60*u4+120*u5+126*u2*z2+132*z4
-204*z3*u-121*u3*z2+2*u3*z3-111*u2*z3+48*u5*z5+90*u8*z4
-204*u9*z3+680*u5*z-66*u5*z2-186*u7*z+114*u7*z5+132*u10*z4
+118*u6*z-246*u5*z4+90*u*z4+195*u4*z3-111*u8*z3+126*u8*z2
+27*z4*u3+118*u4*z-264*u6*z4-121*u7*z2+195*u6*z3+114*z5*u3
-264*z4*u4+2*u7*z3-132*u9*z5+90*u9*z4+84*z5*u4+27*u7*z4
+84*u6*z5-90*u8*z5-292*u6*z2+620*u5*z3+90*z4*u2-132*z5*u
-90*z5*u2-186*u3*z-292*u4*z2)/(1-u)/(1+u)/(1-u*z)/(u-z)/u3
  * (log(1+u)-1./2.*log(u)) * log(u)
// sym^2
- 1./144. * (1-z) * (-324*u6-96*u7-96*u3-324*u4-456*u5+66*u2*z2+132*z4
+132*z5-204*z3*u+281*u3*z2-327*u3*z3-437*u2*z3-132*u4*z6+386*u5*z5
+7*u8*z4-204*u9*z3-816*u5*z+414*u5*z2-150*u7*z-132*u6*z6+329*u7*z5
+132*u10*z4+132*u10*z5-438*u6*z+558*u5*z4-132*u9*z6+126*u*z4+715*u4*z3
-437*u8*z3-48*u5*z6-330*u8*z6+66*u8*z2+165*z4*u3-306*z6*u3-438*u4*z
+1127*u6*z4-132*z6*u+281*u7*z2+715*u6*z3+329*z5*u3-330*z6*u2+1127*z4*u4
-327*u7*z3+198*u9*z5+126*u9*z4+600*z5*u4+165*u7*z4+600*u6*z5-306*u7*z6
+180*u8*z5+974*u6*z2-254*u5*z3+7*z4*u2+198*z5*u+180*z5*u2-150*u3*z
+974*u4*z2)/u3/up12/(1-u*z)/(u-z)/(z+1)
    * log(u) * log(u)
// asym^2
-1./36.*(12*u3+168*u4+12*u5-12*u2*z+53*u2*z2-6*z4+6*z5-21*z3*u
+328*u3*z2-185*u3*z3-129*u2*z3-24*u5*z5-6*u8*z4-266*u5*z
+328*u5*z2+6*u6*z6-12*u6*z+135*u5*z4+27*u*z4-418*u4*z3
+135*z4*u3-244*u4*z-19*u6*z4-6*z6*u-129*u6*z3-24*z5*u3
+6*z6*u2+206*z4*u4-21*u7*z3-6*z5*u4+27*u7*z4-27*u6*z5
-6*u7*z6+6*u8*z5+53*u6*z2-185*u5*z3-19*z4*u2-27*z5*u2
-266*u3*z+550*u4*z2)/u2/(u-z)/(1-u)/(1+u)/(1-u*z)
   * log(2.) * log(u)
// sym^2
-1./36.*(1-z)*(36*u3+72*u4+36*u5-40*u2*z+4*u*z2-63*u2*z2+2*z4
+27*z3*u-358*u3*z2-83*u3*z3+72*u2*z3+2*u8*z4-138*u5*z
-358*u5*z2-2*u7*z5-40*u6*z-176*u5*z4+2*u*z4+176*u4*z3
-176*z4*u3-52*u4*z-27*u6*z4+4*u7*z2+72*u6*z3-154*z4*u4
+27*u7*z3+2*u7*z4-2*u6*z5-63*u6*z2-83*u5*z3-27*z4*u2
-2*z5*u-2*z5*u2-138*u3*z-150*u4*z2)/(u-z)/up12/(1-u*z)/u2
   * log(2.) * log(2.)
// asym^2
- 1./18. * (1-z)*(36*u3-72*u4+36*u5-36*u2*z-31*u2*z2+6*z4+5*z3*u
+108*u3*z2+23*u3*z3-8*u2*z3+6*u8*z4+114*u5*z+108*u5*z2
-6*u7*z5-36*u6*z-10*u5*z4-6*u*z4-72*u4*z3-10*z4*u3-108*u4*z
-5*u6*z4-8*u6*z3-10*z4*u4+5*u7*z3-6*u7*z4+6*u6*z5-31*u6*z2
+23*u5*z3-5*z4*u2-6*z5*u+6*z5*u2+114*u3*z-130*u4*z2)
/u2/(u-z)/(1-u)/(1+u)/(1-u*z)
   * (log(r+1)-1./2.*log(r)) * log(u)
// asym^2
+ 1./6. * (1-z)*(1-u)*(2*u4*z3+5*u3*z2+2*u3*z3+8*u2*z2-12*u2-10*u2*z
+2*u2*z3+5*u*z2+2*z3*u+2*z3)/(1+u)/u2 
   * (log(abs(r-1))-1./2.*log(r)) * log(u)
// sym^2
- 1./9. * (-48*u+12*u*z-204*u2-312*u3-204*u4-48*u5+26*u2*z+10*u*z2+15*
u2*z2-5*z3-14*z3*u+22*u3*z2-20*u3*z3-25*u2*z3+12*u5*z+10*u5*z2+5*
u5*z4+5*u*z4-25*u4*z3+36*z4*u3+26*u4*z-5*u6*z3+21*z4*u4-14*u5*z3
+21*z4*u2+32*u3*z+15*u4*z2)*(-1+z)/up12/(-1+u*z)/(z-u)/u
   * log(1+t*r) * (log(r+t) - 1./2.*log(u))
// asym^2
+ 8./9. * (1-z) * (-6-24*u+3*u*z+z2-36*u2-24*u3-6*u4+2*u2*z+u4*z2
+9*u3*z2+3*u3*z+4*u2*z2+9*u*z2+3*z4*u3+9*z3*u+3*u*z4+2*z4*u2
+9*u3*z3+4*u2*z3+u4*z3+z3)/(1-u*z)/(u-z)/up12
   * log(1-t*r) * (log(r-t) - 1./2.*log(u))
+ 1./18. * (1-z)/u/(1+z)/up12/(u-z)/(1-u*z) * 
(-40*z3-9*z2-31*z4-27*u*z+72*u3+36*u2+36*u4-28*u2*z-228*u3*z3
-30*u*z2+13*u2*z2-348*u3*z2+222*u2*z3+29*u5*z5-27*u5*z
-30*u5*z2+24*u5*z4+24*u*z4+222*u4*z3-100*z4*u3-31*u6*z4
-40*u6*z3-86*z5*u3+213*z4*u4+38*z5*u4-9*u6*z2-16*u5*z3
+213*z4*u2+29*z5*u+38*z5*u2+13*u4*z2-16*z3*u-28*u4*z-106*u3*z
+2*u4*z6+4*z6*u3+2*z6*u2)
   * Z2 
// q^1 terms
- 2./9. * z*(1-z)*(u+4*z*(1+u))/up13 
  * (12+33*u+12*u3-2*u*z-2*u2*z+32*u2+4*u3*z+4*u4*z)
   * J27(y,z)
- 2./9. * z*omz2*up12/(1+z)/(u-z)/(1-u*z) * (10+12*z+3*z2)
  * log((1.+z)/2.)
- 1./9. * omz2*up12/(1+z)/(u-z)/(1-u*z) * (33+70*z+36*z2+30*z3-4*z4) 
  * log(1.-z)
- 4./9. * t/r * z*(1-z)/(1-u*z)/(u-z)/(1+u) 
       * (9*u*z2+9*u3*z2-5*z-26*u2*z-5*u4*z+9*u+9*u3)
  * log((r+t)/2./t)
- 2./9.*(1-z)/(1+z)/u2/up12/(1-u*z)/(u-z) *  ( 
  - t/r * z*(1+z)*(1+u) 
      * (66*z2+174*u5*z2-85*u5*z-80*u7*z+174*u3*z2-108*u2*z3
       -80*u*z+67*u3+24*u2+22*u4+67*u5+24*u6-153*u2*z-54*u3*z3
       +134*u2*z2+108*u*z2-153*u6*z-24*u4*z3+108*u7*z2-108*u6*z3
       -66*u7*z3+134*u6*z2-54*u5*z3+100*u4*z2-66*z3*u+66*u8*z2
       -152*u4*z-85*u3*z) 
+ 33*z3+99*z4+66*z5+148*u5*z5+35*u5*z2-79*u5*z+93*u*z4+209*u5*z4
 +181*u3*z2-110*u2*z3-33*u3-99*u4-99*u5-33*u6-25*u6*z5+46*u2*z
 +99*u8*z4+213*u3*z3-18*u2*z2-36*u*z2-57*u6*z-126*u4*z3
 +195*z4*u3-45*u6*z4-36*u7*z2-242*u6*z3+114*z5*u3-8*z4*u4
 -51*u7*z3+149*z5*u4+93*u7*z4-140*u6*z2+123*u5*z3-z4*u2
 +42*z5*u-29*z5*u2-129*u4*z2-43*z3*u+42*u7*z5+33*u8*z3-72*u4*z
 +103*u3*z+66*u8*z5-55*u4*z6-141*u6*z6-101*u5*z6-101*z6*u3
 -66*u7*z6-141*z6*u2-66*z6*u )
  * log((r-t)/t)
- 1./9. /up13/u3/(1+z)/(1-z)/(1-u)/(u-z)/(1-u*z)/(z*up12-4*u2)
   * ( -316*z5+316*z6-1611*u9*z2+3149*u5*z5+4612*u5*z2
  -770*u5*z+2312*z9*u3-512*u10*z2+102*z6*u11-116*z8*u10
  +2086*u9*z+910*u8*z-2226*u7*z+540*u*z4+5051*u5*z4+110*u3*z2
  -228*u2*z3+10*u11*z-1622*z9*u5+316*z7-316*z8+264*u6+792*u7
  +528*u8-528*u9-792*u10-264*u11+642*u11*z3+56*z2*u12+316*z9*u
  +58*u12*z3-118*z5*u12+1670*z7*u-4298*z8*u2+8822*z8*u6+86*u11*z2
  +650*u10*z-154*z4*u12+38*z6*u12+8*z8*u9+212*z7*u10+32*z7*u11
  +1446*z9*u2-1821*u9*z7-8*z8*u11+2614*u8*z8+56*u11*z5
  -6706*u4*z8+908*z9*u4+345*u10*z6+8098*z8*u7+38*z9*u9
  -2234*z9*u6-7018*u3*z8+5204*u2*z7-128*z9*u8+682*u5*z8
  -1044*z9*u7+8*z9*u10-1762*z8*u+7677*u6*z5-10388*u8*z4
  -3406*u3*z3-2386*u6*z-9266*u4*z3+10900*z4*u3-6141*u6*z4
  -193*u7*z2-244*u6*z3-9156*z5*u3+13418*z4*u4+5573*u7*z3
  -4166*z5*u4-10568*u7*z4+4507*u6*z2-8849*u5*z3+4010*z4*u2
  -1986*z5*u-6434*z5*u2+1584*u4*z2+3296*u9*z3+9556*u7*z5
  -1905*u10*z4+4711*u8*z3-2623*u8*z2-66*u4*z+1705*u9*z5
  -6491*u9*z4+6268*u8*z5-7020*u4*z6-2252*u6*z6-7025*u5*z6
  +6381*u8*z6-3620*z6*u3+4463*u7*z6-13971*u7*z7-7293*u6*z7
  +2998*u9*z6+11034*u4*z7+9958*z7*u3+340*z6*u2-9153*u8*z7
  +4452*u5*z7+2209*u10*z3+421*u10*z5-576*u11*z4+1222*z6*u )
   * ( log((r+t)/(1+u)) + 2. * u*(3+u2)/omu3 * log(z) 
     - 1./2. * up13/omu3 * log(u) )
- 1./18. /(1-z)/(1+z)/up12/u3/omu4/(u-z)/(1-u*z)
  * ( + 316*z4*omz2*(1+z)
     - 2*z3*omz2*(1+z)*(158*z2-1545*z+270) * u
     -2*z2*(-142+2759*z+2024*z3-5685*z2+4316*z4+1545*z6-4717*z5) * u2 
     -2*(5440*z6+17*z+165+6226*z3-1207*z2-6075*z7+2902*z8+188*z5
        -7576*z4) * u3
     - (-6407*z2+984*z8+528+784*z-6926*z7+7814*z6-3987*z4+7903*z3
         -973*z5) * u4
     + (3161*z2+264-3609*z+2101*z6-9914*z4+4548*z8-6850*z7+6132*z3
         +5447*z5) * u5
     + (-1268*z+528+4026*z8-18529*z4+12485*z3-2855*z2+6555*z5
        +15830*z6-16852*z7) * u6
     + (2111*z+66+1620*z8-963*z2+5236*z3-13180*z4+775*z5
           +11745*z6-8530*z7) * u7 )
  * log(z) 
+ 1./18./(1-z)/up13/(z+1)/(u-z)/(1-u*z)/omu3/u3
* ( + 316*z4*omz2*(1+z)
    - 2*z3*omz2*(1+z)*(158*z2-1045*z+336) * u
    - 2*z2 * (2306*z3+1045*z6-4305*z5+2025*z+4062*z4-186-4927*z2) * u2
    -2*(-33-10886*z4+5982*z3+2924*z8+8508*z6+3478*z5+73*z
        -801*z2-9285*z7) * u3
    - (9028*z8+904*z-4763*z2+26362*z6-27178*z7-528+6451*z5
      -33327*z4+22931*z3) * u4
    - (-10929*z2-1848+3209*z+31367*z6-36590*z4+8272*z8-28690*z7
       +31924*z3+3605*z5) * u5
    - (-22776*z7+4530*z8-687*z5-3696-16013*z2+34467*z3-34735*z4
      +31138*z6+7852*z) * u6
    - (16856*z3+5417*z-17140*z4+1212*z8-1587*z5-8601*z2-9214*z7
      -2310+15127*z6) * u7 )
  * log(u)
- 2./9. * t/r * z/up12 * ( 
  z2 * (1+u2)*u3*(3+u)/(z*up12-4) 
  - 1./(u-z)/(1-u*z)/(1-u)/u2 * ( 3*z2*(1-z)*(z+22)
      + z * (3*z4+191*z-170*z2+57*z3-80) * u
      + (24+6*z5-179*z3+100*z4+220*z2-173*z) * u2
      + 2. * (-7*z4+2*z5-8*z3+33*z2+25-44*z) * u3 
      + (-133*z4+14+93*z-208*z2+230*z3+2*z5) * u4
      + (62*z-171*z2-28+z5+204*z3-67*z4) * u5 ) )
  * log(u)
// q^0 terms
- 2./9. * t/r * z2 * u2*(1-u)*(2+z+z*u)*(1+u2)/up12/(z*up12-4)
- 2./27. * t/r * z/u2/(1+u)/(u-z)/(1-u*z) * ( 276*z2*(1-z)
     + z * (-816*z2+276*z3+806*z-269) * u
     + (1318*z2-800*z-1052*z3-27+540*z4) * u2
     + (-501*z+240+1067*z2-1067*z3+246*z4) * u3
     - 3./2. * (-14+3*z4+191*z3+147*z-353*z2) * u4 ) 
- 1./18. * z3*u*omu4/up13/(u-z)/(1-u*z) /(z*up12-4.)
      * (2+z+z*u)*(2-u*z)*(4+z+2*u+z*u)
+ 1./54. * z/(1+z)/u2/up12/(u-z)/(1-u*z) * (
      6*z2*(1+z)*(1-z)*(184*z+191)
    + 3*z*(1+z)*(368*z4-693*z3-98*z2+804*z-384) * u
    + (-278*z2+2304*z3-1567*z4+2118*z6-3308*z-74+643*z5) * u2
    + (-104*z+22*z3+3652*z2-1113*z5+632*z6+664-3903*z4) * u3
      - (1278*z-1788*z2+360+77*z4+346*z6+373*z5-976*z3) * u4 );
 return temp;
}

// u -> 1 limit of qbarq_no_NF :

double qbarq_no_NF_u1(double z){
 double t,z2,z3,z4,z5,z6,ln2,lnz,ln1mz,tp12,lntp1,temp;
 t = sqrt(z);  
 ln2 = log(2.);  lnz = log(z);  ln1mz = log(1.-z);  
 tp12 = (1.+t)*(1.+t);  lntp1 = log(1.+t);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;  z5 = z3*z2;  z6 = z3*z3;
 temp = 
- 4./9.*(121*z5-301*z4+224*z3-16*z3*t-32*z2*t-53*z2-37*z-16*t*z+18)
   /(-1+z) * ln2 * lntp1
- 1./9.*z*(-1+z)*(671*z3*t-289*z3-223*z2*t-15*z2-411*t*z+349*z+171*t-237)
   /(t+1)/(z+1) * ln1mz
+ 512./9.*(z2+1)*z2/(-1+z)/(z+1) * log(z+1) * ln1mz
+ 8./9.*(60*z5-134*z4+86*z3-16*z3*t-32*z2*t-37*z2+17*z-16*t*z-6)/(-1+z) 
     * lnz * lntp1
+ 1./36.*(2820*z5+6660*z5*t-7128*z4-19800*z4*t+20311*z3*t+3735*z3-558*z2
          -10990*z2*t-245*z+2827*t*z-384*t)/(t+1)/(-1+z) * lntp1
+ 1./72.*(1392*z5*t-3840*z5+880*z4*t+4352*z4-385*z3*t+3328*z3-3487*z2*t
         -4288*z2+4753*t*z+960*z-1361*t+384)*t/(-1+z)/(z+1) * lnz
+ 2./9.*(361*z6-540*z5+722*z5*t-491*z4-1882*z4*t+900*z3*t-39*z3-492*z2
        -818*z2*t-25*z-166*t*z+18+36*t)/tp12/(-1+z) * lntp1*lntp1
- 16./9.*z*(3*z2+12*z+10)/(z+1) * log(1.+z)
- 8./9.*(120*z5-180*z4+240*z4*t-191*z3-632*z3*t-73*z2+250*z2*t-185*z
      -332*t*z-3-38*t)*z/tp12/(-1+z) * ln1mz * lntp1
//
+ 2./9. * PISQ6 * (117*z6-122*z5-80*z4*t+100*z4-240*z3*t+300*z3-240*z2*t
         +85*z2-80*t*z+110*z-30)/(-1+z)/(z+1)
- 2./9.*(119*z6-148*z5-16*z4*t-273*z4-48*z3*t+131*z3-48*z2*t-248*z2
        -16*t*z-243*z-306)/(-1+z)/(z+1) * ln2*ln2
- 256./9.*(z2+1)*z2/(-1+z)/(z+1) * log(1.+z) * ln2
- 1./36.*(3976*z6-7008*z5+320*z4*t-1737*z4-1120*z3*t+6977*z3-384*z2*t
        -3551*z2+672*t*z+543*z-384*t-1056)/(-1+z)/(z+1) * ln2
- 64./9.*z*(-1+z)*(z3+3*z2*t-3*z2-6*t*z-3*z+3*t+1)/tp12/(z+1) * ln1mz*ln1mz
+ 8./9.*(120*z6-164*z5-16*z4*t-223*z4-48*z3*t+151*z3-48*z2*t-217*z2
        -16*t*z-83*z-96)/(-1+z)/(z+1) * ln2 * ln1mz
- 1./9.*(6-741*z3+529*z2-312*z+365*z5-439*z4)*z/(-1+z)/(z+1) * lnz*lnz
+ 2./9.*z*(8*z6-68*z3+113*z2+31*z+26*t+13+19*z5+196*z2*t-152*z4
        -232*z3*t-24*t*z+34*z4*t)/(-1+z)/(z+1)/tp12 * lnz * log(1.+z)
+ 1./9.*(242*z6-305*z5+64*z4*t-1322*z4+192*z3*t+412*z3+192*z2*t
        -1124*z2+64*t*z+5*z+12)/(-1+z)/(z+1) * lnz * ln1mz
- 2./9.*z*(30+490*z6-145*z5-1427*z4-204*z3+105*z2-1026*t*z+60*t-453*z
        +1182*z2*t-1490*z3*t+964*z5*t-1258*z4*t)/(-1+z)/(z+1)/tp12 
         * ln2 * lnz
+ 1./54.*(115*z+576*t+2641*z3-3627*z2+3347*z4-2476*z5-2471*z4*t
        -197*z3*t-1829*t*z+1063*z2*t+1754*z5*t)/(t+1)/(z+1)
//
- 2./9.*(242*z5-569*z4+64*z3*t+411*z3+128*z2*t+z2+64*t*z-57*z+36)/(-1+z) 
   * li2(-t)
- 2./9.*(238*z5-491*z4-64*z3*t+671*z3-128*z2*t-57*z2-64*t*z+131*z-12)/(-1+z)
   * li2(t)
- 4./9.*(121*z5-237*z4-48*z3*t+222*z3-96*z2*t+35*z2-48*t*z+37*z-6)/(-1+z)
   * li2((1.-t)/2)
+ 2./9.*z*(17*z3+6+44*z2-27*z)/(-1+z) * li2(z)
+ 2./9.*z*(17*z3-5*z2+13+103*z)/(-1+z) * li2(-z)
+ 2./9.*z*(z+1)*(17*z2+13+34*z)/(-1+z) * li2((1.+z)/2.)
//
+ 16./9.*(-1+z)*(z3+7*z2-11*z+6)*J2_u1(z)
+ 8./3.*(-1+z)*(z2+2*z+4) * J3_u1(z)
+ 1./18.*(-1+z)*(8*z+1)*(4*z+89)*z * J27_u1(z)
+ 4./9.*z2*(8*z3-14*z2-33*z+30) * J21_u1(z) ;
  return temp;
}

// u -> z limit of qbarq_no_NF :

double qbarq_no_NF_uz(double y, double z){
 double u,r,t,Z2,z2,z3,z4,z5,z6,ln2,lnz,ln1mz,ln1pz,temp;
 u = (z+y*(1.-z))/(1.-y*(1.-z));   t = sqrt(z);   r = sqrt(u);
 Z2 = PISQ6;
 ln2 = log(2.);  lnz = log(z);  ln1mz = log(1.-z);  ln1pz = log(1.+z);  
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;  z5 = z3*z2;  z6 = z3*z3;
 temp = 
// log-divergent terms:
- 8./9. * (3*z4-5*z3+17*z2+9*z+6)/(1+z) * log(r-t)*log(r-t)
+ ( 2./9.*(24-49*z2+38*z-107*z4+181*z3+41*z5)*lnz/(-1+z)/(1+z)
   -1./9.*(8*z5-109*z4+100*z3-439*z2-326*z-108)/(1+z)
   +2./9.*(5*z5+53*z4-21*z3-31*z2-64*z-6)*log((1+z)/2)/(-1+z)/(1+z)
   -16./9.*ln1mz*(3*z4-5*z3+17*z2+9*z+6)/(1+z) ) * log(r-t)
// finite terms:
+2./9.*(41*z+33*z3+35*z2+2*z5-33*z4-42)*li2((1.+z)/2)/(-1+z)/(1+z)
-2./9.*ln2*(4*z6-18*z5-4*z4-102*z3+76*z2+125*z+33)/(-1+z)/(1+z)
+1./9.*(-36+143*z+168*z3+21*z5-116*z4+12*z2)*ln2*ln2/(-1+z)/(1+z)
-2./9.*(-27*z3-173*z2+z5-10*z+85*z4+84)*li2(-z)/(-1+z)/(1+z)
+2./9.*ln1pz*(4*z6-18*z5-4*z4-102*z3+76*z2+125*z+33)/(-1+z)/(1+z)
-2./9.*(-6-61*z2+3*z-159*z4+127*z3+34*z5)*lnz*lnz/(-1+z)/(1+z)
+1./18.*lnz*(40*z6-131*z5+923*z4-1653*z3+191*z2+142*z-216)/(-1+z)/(1+z)
-8./9.*ln1mz*ln1mz*(-29*z3-7*z2-39*z-18+3*z4)/(1+z)
+4./3.*(-1+z)*(z2+1)*z*ln2*log(1+2*z)/(1+z)
+8./3.*(-1+z)*(z2+1)*z*lnz*log(1+2*z)/(1+z)
-4./3.*(-1+z)*(z2+1)*z*ln1pz*log(1+2*z)/(1+z)
-1./9.*(-21*z4+180*z3-327*z2+50*z+24+8*z5)*ln1mz/(1+z)
+4./9.*log((1.+z)/2.)*ln1mz*(-24+31*z2-10*z+39*z4+9*z3+5*z5)/(-1+z)/(1+z)
-1./9.*(65*z6+186*z5-262*z4-330*z3+319*z2+232*z-258)/(-1+z)/(-1+z)/(1+z)
    *lnz*ln1pz
-2./27.*(44*z5+11*z4-138*z3+277*z2+298*z+120)/(1+z)
-2./9.*z*(31*z3-78*z2+23*z-4)*li2(z)/(1+z)
+4./9.*(12-89*z2+22*z-103*z4+84*z3+10*z5)*lnz*ln1mz/(-1+z)/(1+z)
+1./9.*(-74*z4-82*z2+29*z5+126*z3+73*z+48)*ln1pz*ln1pz/(-1+z)/(1+z)
+1./9.*z*(-93*z3+193*z+13*z4-37*z2-108) * PISQ6/(-1+z)/(1+z)
+1./9.*(90*z5+58*z3+39*z6-134*z4-79*z2+68*z-90)*lnz*ln2/(-1+z)/(-1+z)/(1+z)
-2./9.*(108*z+147*z3-35*z2+25*z5-95*z4+6)*ln1pz*ln2/(-1+z)/(1+z)
+ 4./3.*(-1+z)*(z2+1)*z/(1+z) * J2rem(z) ;
 return temp;
}

// z -> 1 limit of qbarq_no_NF:

double qbarq_no_NF_z1(double y, double z){
  double a,a2,a3,a4,y2,y3,y4,lna,lna2,lny,lny2,ln1my,ln1my2;
  a = 1.-z;  
  a2 = a*a;   a3 = a2*a;   a4 = a2*a2;  
  y2 = y*y;   y3 = y2*y;   y4 = y2*y2; 
  lna = log(a);  lny = log(y);  ln1my = log(1.-y);
  lna2 = lna*lna;   lny2 = lny*lny;  ln1my2 = ln1my*ln1my; 
 return -40/3.*ln1my2/y+293/9.*ln1my/y-160/3./y*lna*ln1my
        +80/3./(-1+y)/y*lny*ln1my+160/3./(-1+y)*lny*lna
        +40/3./(-1+y)*lny2-293/9./(-1+y)*lny
  +a*(16/9.*ZETA2-4/9.*(2*y-27)/y*ln1my2+7/18.*(-117+4*y)*ln1my/y
    -16/9.*(2*y-27)/y*lna*ln1my-8/9.*(2*y2+27-2*y)/(-1+y)/y*lny*ln1my
    -4/9.*(2*y+25)/(-1+y)*lny2+7/18.*(4*y+113)*lny/(-1+y)
    -16/9.*(2*y+25)/(-1+y)*lna*lny+28/9.*lna-281/18.-32/9.*lna2)
  +a2*(-8/3.*ZETA2+2/3.*(2*y-7)/y*ln1my2+1/108.*(-922*y+2831+968*y2)*ln1my/y
    +8/3.*(2*y-7)/y*lna*ln1my+4/3.*(2*y2+7-2*y)/(-1+y)/y*lny*ln1my
    +2/3.*(2*y+5)/(-1+y)*lny2-1/108.*(-1014*y+968*y2+2877)*lny/(-1+y)
    +8/3.*(2*y+5)/(-1+y)*lna*lny+3547/108.-73/9.*lna+16/3.*lna2)
  +a3*(2/9.*(13-36*y+36*y2)*ZETA2+1/9.*(3+10*y+10*y3-10*y2)/y*ln1my2
    -1/216.*(8*y-436*y2+2412*y3+1041)*ln1my/y
    +4/9.*(3+10*y+10*y3-10*y2)/y*lna*ln1my
    +2/9.*(-3-10*y+20*y2-20*y3+10*y4)/y/(-1+y)*lny*ln1my
    +1/9.*(-20*y2+10*y3-13+20*y)/(-1+y)*lny2
    -1/216.*(-6800*y2+2412*y3-3025+6372*y)*lny/(-1+y)
    +4/9.*(-20*y2+10*y3-13+20*y)/(-1+y)*lna*lny-100169/5184.*y
    -8891/1728.+100169/5184.*y2-1/9.*(83+201*y2-201*y)*lna+40/9.*(1+y2-y)*lna2)
  +a4*(7093553/259200.*y+1/36.*(531+689*y2-689*y)*lna
    +1/2160.*(-32660*y2+13510*y3+30740*y+2864*y4-11713)*lny/(-1+y)
    -(-1+2*y)*(-1+2*y)*ZETA2-1/18.*(10*y3-10*y2-3+14*y)/y*ln1my2
    -1/18.*(-20*y2+10*y3-11+24*y)/(-1+y)*lny2
    -2/9.*(-20*y2+10*y3-11+24*y)/(-1+y)*lna*lny-7093553/259200.*y2
    -1/2160.*(-17406*y+25054*y2-24966*y3+2864*y4+2741)*ln1my/y
    -4303849/259200.-2/9.*(10*y3-10*y2-3+14*y)/y*lna*ln1my
    -1/9.*(-20*y3+10*y4+24*y2+3-14*y)/y/(-1+y)*lny*ln1my
       -4/9.*(7+5*y2-5*y)*lna2) ;
}

// Full, patched, no-NF result:

double qbarq_no_NF(double y, double z){
  // z = 1 patch:
  if (abs(1.-z) < 0.1){ return qbarq_no_NF_z1(y,z); }
  // u = 1 patch:
  if (abs(y-0.5) < 0.002/sqrt(1.-z)){ return qbarq_no_NF_u1(z); }
  // u = z patch:
  if (y < 0.00001/sqrt(1.-z)){ return qbarq_no_NF_uz(y,z); }
  // u = 1-z patch (will require separate patch function for asym q g case):
  if (1.-y < 0.00001/sqrt(1.-z)){ return qbarq_no_NF_uz(1.-y,z); }
  // z = (2*u/(1+u))^2 patch (average values on either side of strip):
  double eps = 1.0e-07;
  if (abs(y-y_sing(z)) < eps){ 
    return 0.5 * ( qbarq_no_NF(y_sing(z)-2.*eps,z) 
		 + qbarq_no_NF(y_sing(z)+2.*eps,z) );
  }
  if (abs(y-(1.-y_sing(z))) < eps){ 
    return 0.5 * ( qbarq_no_NF(1.-y_sing(z)-2.*eps,z) 
		 + qbarq_no_NF(1.-y_sing(z)+2.*eps,z) );
  }
  else { return qbarq_no_NF_1(y,z) + qbarq_no_NF_1(1.-y,z); }
}

// Nf terms:

double qbarq_NF_1(double y, double z){
 double u,t,r,z2,z3,z4,u2,u3,u4,temp;
 u = (z+y*(1.-z))/(1.-y*(1.-z));   t = sqrt(z);   r = sqrt(u);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;
 u2 = u*u;  u3 = u2*u;  u4 = u2*u2;
 temp = 
  4./9. * ( 
   - 0.5 * (-2*u4*z+2*u3*z2-u3*z+u3+2*u2*z2+5*z*u2+5*u2
         -4*z2*u-3*u*z+u+1+z) * (1-z)*u*z/(u-z)/(1+u)/(1+u)/(1-u)
      * log(u*(1-z)*(1-z)/z/(1-u*z)*(1+t*r)/(1-t*r))
   - (-3*z4*u+z4+2*z4*u2+5*u2*z3-4*z3*u-2*u3*z3+z3+3*u2*z2
         +2*z2-z2*u-2*u3*z2+2*z-u2+1) * (1-z)/(u-z)/(1+z)/(1-u)
      * log((1-u*z)/(1-z)/(1+u))
  - ((1+z2)*(1+u2) - 4*u*z) * z * (1-z)/(1+z)/(1+u)/(1+u)
      * log(z/(1-z))
  + 1./3. * z*(1-z)/r/(1+t*r)/(r+t)/(1+u)/(1+u)/(1+z) * ( 
        2 * (1+z) * (3*z-u*(4-6*z+7*z2)+u2*z*(11-3*z))
	- t*r * (1+u) * (5-9*z+8*z2+u*z*(3*z-19)) ) );
 return temp;
}

// z -> 1 limit of qbarq_NF:

double qbarq_NF_z1(double y, double z){
  double a,a2,a3,a4,y2,y3,lna,lny,ln1my;
    a = 1.-z;  
    a2 = a*a;   a3 = a2*a;   a4 = a2*a2;  
    y2 = y*y;   y3 = y2*y; 
    lna = log(a);  lny = log(y);  ln1my = log(1.-y);
 return -10/9.*ln1my/y+10/9./(-1+y)*lny
   +a*(ln1my/y-1/(-1+y)*lny+13/18.)
   +a2*(-7/18.*ln1my/y+7/18./(-1+y)*lny-97/108.)
   +a3*(1/36.*(1+8*y+16*y3-16*y2)/y*ln1my+4/9.*(2*y2+1-2*y)*lna
      +1/36.*(-9+24*y-32*y2+16*y3)/(-1+y)*lny-251/432.+697/432.*y-697/432.*y2)
   +a4*(-1/72.*(8*y-1-16*y2+16*y3)/y*ln1my-2/9.*(2*y2+1-2*y)*lna
      -1/72.*(-32*y2+24*y+16*y3-7)/(-1+y)*lny+383/480.+247/160.*y2-247/160.*y);
}

// Full, patched, NF result:

double qbarq_NF(double y, double z){
  // z = 1 patch:
  if (abs(1.-z) < 0.01){ return qbarq_NF_z1(y,z); }
  else { return qbarq_NF_1(y,z) + qbarq_NF_1(1.-y,z); }
}

// NFf terms:

double qbarq_NFf_1(double y, double z){
 double u,t,r,z2,u2,up14,temp;
 u = (z+y*(1-z))/(1-y*(1-z));   t = sqrt(z);   r = sqrt(u);
 z2 = z*z;    u2 = u*u;    up14 = (1.+u)*(1.+u)*(1.+u)*(1.+u);
 temp = 
   - 2./3. * z*(1-z) * u * (1+4*z+z2-u*z)/up14 * log(u/z)*log(u*z)
   + 2./3. * ( u * z*(1-z)*(1-z)*(1+z)*(5-4*u)/up14 * log(z)
   + z*(1-z)*(1-u)/up14 * ( (1+u) * (z-u*(1+4*z+z2)) 
                             - 4. * t*r * (1+z)*(1-2*u) ) * log(u) )
   + z*(1-z)*(1-u*z)*(u-z)/r/(1+t*r)/(r+t)/up14 
         * ( 2*u*(1+z)*(3-4*u) - t*r * (1+u)*(1+u2) );
 return temp;
}

// z -> 1 limit of qbarq_NFf:

double qbarq_NFf_z1(double y, double z){ 
 return 0.;
}

double qbarq_NFf(double y, double z){
  return qbarq_NFf_1(y,z) + qbarq_NFf_1(1.-y,z);
}

// The "NFf" q-\bar{q} real "hard" term, including conversion factor:

double qbarq_NFf_real_hard(double y, double z){
  return real_conv(y,z) * qbarq_NFf(y,z) ;
}

//====================================================================
// "Boost" soft limits:

double qbarq_boost_mu_soft(double z, double Nf, double muFQ){ 
 double Z2, lnmu;
 Z2 = ZETA2;   lnmu = 2.*log(muFQ);
 return (32/9. * DD1(1.,1-z) + (5/6. + 1/9. * Nf) * DD1(0.,1-z)) * lnmu*lnmu
  + ( - 32/3. * DD1(2.,1-z) 
      + (2 - 4/9. * Nf) * DD1(1.,1-z)
      + (2/9. * Z2 - 1/3. + 10/27. * Nf) * DD1(0.,1-z) ) * lnmu;
}

// muR <> muF part:

double qbarq_boost_muR_soft(double z, double Nf, double muFQ, double muRQ){ 
  double C_A = 3.;
  return 1/4. * (11/3. * C_A - 2/3. * Nf) * 2. * log(muRQ/muFQ) 
              * NLO_qbarq_boost_soft(z,muFQ);
}
 
double qbarq_boost_soft(double z, double Nf, double muFQ, double muRQ){ 
 double Z2, Z3, ln1mz, ln1mz2, ln1mz3;
 Z2 = ZETA2;  Z3 = ZETA3;
 ln1mz = log(1.-z);  ln1mz2 = ln1mz*ln1mz;   ln1mz3 = ln1mz2*ln1mz;
 return 64./9. * ln1mz3/(1.-z)
   + ( - 22./3. + 4./9. * Nf ) * ln1mz2/(1.-z)
   + ( - 4./9. * Z2 + 2./3. - 20./27. * Nf ) * ln1mz/(1.-z)
   + ( 95./9. * Z3 + 11./3. * Z2 - 202./27. 
     + ( - 2./9. * Z2 + 28./81. ) * Nf )/(1.-z)
 + qbarq_boost_mu_soft(z,Nf,muFQ) 
 + qbarq_boost_muR_soft(z,Nf,muFQ,muRQ) ;
}

// no-DD1 terms:  

double qbarq_boost_mu_hard(double z, double Nf, double muFQ){ 
 double Z2, z2, ln2,lnz, ln1mz,ln1pz,lnhf1pz, lnmu, temp;
 Z2 = ZETA2;  ln2 = log(2.);  lnz = log(z);  ln1mz = log(1.-z);
 ln1pz = log(1.+z);  lnhf1pz = log((1.+z)/2.); z2 = z*z;
 lnmu = 2.*log(muFQ);
 temp = ( - 2/9. * (5+7*z2)/(1-z) * lnz
       - 16/9. * (1+z) * ln1mz + 8/9. * (1+z2)/(1-z) * lnhf1pz 
       - 1/36. * (31-z) ) * lnmu*lnmu
+ ( - 8/9. * lnz - 55/9. 
    - 8/9. * (1+z2)/(1-z) * ( 49/16. * lnz*lnz - 9 * lnz * ln1mz
        - 2 * lnz * lnhf1pz + 4 * ln1mz * lnhf1pz
	+ 15/8. * lnz )
+ 1/9. * (1+z) * ( 4 * li2(z) - 4 * li2(-z) + 6 * lnz*lnz
                - 4 * lnz * log((1.-z)*(1.+z)) + 48 * ln1mz*ln1mz
                + 9 * lnz - 9 * ln1mz - 7 * Z2 + 29 ) ) * lnmu
//
+ 1/9. * Nf * ( - 1/2. * (1+z) * lnmu*lnmu
+ ( 2 * (1+z2)/(1-z) * lnz + 2 * (1+z) * ln1mz - 2/3. * (1+4*z) ) * lnmu 
	       );
 return temp;
}

double qbarq_boost_muR_hard(double z, double Nf, double muFQ, double muRQ){ 
  double C_A = 3.;
  return 1/4. * (11/3. * C_A - 2/3. * Nf) * 2. * log(muRQ/muFQ) 
              * ( NLO_qbarq_boost(z,muFQ) - NLO_qbarq_boost_soft(z,muFQ) );
}
 
double qbarq_boost_hard(double z, double Nf, double muFQ, double muRQ){ 
 double Z2,Z3,z2,z3,z4,ln2,lnz,lnz2,lnz3,ln1mz,ln1mz2,ln1mz3,
       ln1pz,lnhf1pz,lnhf1pz2,temp;
 Z2 = ZETA2;  Z3 = ZETA3;
 ln2 = log(2.);  lnz = log(z);  lnz2 = lnz*lnz;  lnz3 = lnz2*lnz;
 ln1mz = log(1.-z);  ln1mz2 = ln1mz*ln1mz;   ln1mz3 = ln1mz2*ln1mz;
 ln1pz = log(1.+z);  lnhf1pz = log((1.+z)/2.);  lnhf1pz2 = lnhf1pz*lnhf1pz;
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;
 temp = 1./36. * (1.+z2)/(1.-z) * ( 
   + 92. * li3(2.*z/(1.+z)) - 48. * li3(z) 
   - 16. * li3((1.-z)/2.) - 8. * li3((1.+z)/2.) 
   - 100. * li3(1.-z) + 40. * li3(-z) 
   + 20. * li3((1.-z)/(1.+z)) + 10. * li3(1.-z2)
   - 4. * ( 4. * lnz + 5. * ln1mz ) * li2(z) 
   + 28. * lnhf1pz * ( li2(z) - li2(-z) - lnhf1pz2 )
   + 28. * lnz * li2(-z)
   + 4. * ( 8. * lnz - 9. * lnhf1pz ) * li2((1.+z)/2.)
   + 128. * ln1mz3
   + 4. * ( 32. * lnhf1pz - 83. * lnz ) * ln1mz2
   + 234. * lnz2 * ln1mz + 6. * lnhf1pz2 * log((1.-z)/2.) 
   - 53. * lnz3 + 2. * ( ln2 + 17. * lnhf1pz ) * lnz2 
   + 16. * ( 2. * ln2 * lnhf1pz + 3. * lnhf1pz2 
          - 10. * lnhf1pz * ln1mz ) * lnz 
   + 6. * Z2 * ( 5. * lnhf1pz + 7. * lnz + 2. * ln1mz )
   + 184. * Z3 )
- 7./9. * (1.+z) * ( li3((1.-z)/2.) + li3((1.-z)/(1.+z)) 
          + li3(2.*z/(1.+z)) 
          + ( lnhf1pz - 2. * log(z/(1.-z)) ) 
                  * ( li2(z) - li2(-z) - 3./2. * Z2 ) 
          - 13./12. * lnz3 + 3./2. * log((1.+z)*(1.-z)) * lnz2
          - 2. * ln1pz * ln1mz * lnz + 1./2. * lnhf1pz2 * log((1.-z)/2.)
          - 1./3. * lnhf1pz2*lnhf1pz + Z2 * lnhf1pz - Z3 )
- 1./9./(1.-z) * ( 64. * ln1mz3 - 4. * Z2 * ln1mz + 95. * Z3 )
//
+ 1./9./z/(1-z) * ( 
  + (14.*z+9.*z3-11.*z2+2.*z4-2.) * li2(z)
  - (14.*z-19.*z2+z3+16.) * (li2(-z) + ln2*lnz)
  + (22.*z2-22.*z3-27.*z-8.+2.*z4) * (li2((1.+z)/2.) - ln2*lnhf1pz)
  - 1./2. * (15.*z2-11.*z3-21.*z-18.+2.*z4) * lnhf1pz2
  + (-12.*z+19.*z2-26.+7.*z3) * lnz * lnhf1pz
  + (-23.*z+12.+4.*z2-28.*z3+2.*z4) * ln1mz * lnhf1pz
  - (-66.*z-71.*z3+z2+6.+10.*z4) * lnz * ln1mz
  + 1./4. * (-84.*z-117.*z3+2.*z2+4.+24.*z4) * lnz2
  + 2. * (1.-z) * (2.+18.*z+15.*z2-2.*z3) * ln1mz2
  + 1./2. * z * (35.-107.*z+114.*z2-12.*z3) * Z2 )
//
- 1./27./z/(1.-z) * (27.*z3+33.*z2-10.*z-20.) * lnhf1pz
- 1./54./z/(1.-z) * (76.*z4+101.*z3-87.*z2-50.*z+50.) * lnz
+ 1./54. * (100.+96.*z-129.*z2-88.*z3)/z * ln1mz
+ 1./324. * (268.+285.*z+2007.*z2-136.*z3)/z
// NF terms:
+ Nf * ( 
  + 1./9. * (1.+z2)/(1.-z) * ( li2((1.+z)/2.) - ln2 * lnhf1pz
        - 1./2. * lnhf1pz2 + ln1mz * lnhf1pz
        - 4. * lnz * ln1mz + 2. * ln1mz2 + 7./4. * lnz2 - 2. * Z2 )
  - 2./9./(1.-z) * ( 2. * ln1mz2 - Z2 )
  + 4./27. * (1+4*z) * ln1mz + 1./18./(1.-z) * (7.*z2+7.-4.*z) * lnz 
  - 2./9. * lnhf1pz - 1./162. * (37.+19.*z) ) ;
  return temp + qbarq_boost_mu_hard(z,Nf,muFQ) 
              + qbarq_boost_muR_hard(z,Nf,muFQ,muRQ) ;
}

//====================================================================
// "Real" soft limits:

// q-\bar{q} DD1(n,y) terms, including conversion factor (for y = 0):

double qbarq_real_soft_A(double y, double z, double Nf, double muFQ, double muRQ){
 double Z2,z2,z3,z4,ln2,lnz,lnz2,ln1mz,lnhf1pz,
         temp, lnmu, temp_mu, lnmuR, temp_muR;
 Z2 = ZETA2;
 ln2 = log(2.);  lnz = log(z);  lnz2 = lnz*lnz;
 ln1mz = log(1.-z);   lnhf1pz = log((1.+z)/2.);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;
 lnmu = 2.*log(muFQ);  lnmuR = 2.*log(muRQ/muFQ);
//
 temp =
   // use 1/(1-y) = 1 + y/(1-y),
   //     ln(1-y)/(1-y) = 0 + ln(1-y)/(1-y)
   // and put 2nd terms in "extra" piece...
 + 16./3. * ( 1./(1.-z) - (z3+z2+2.*z+1.)/(1.+z) ) * DD1(2.,y)
 + ( ( 64./3. * ln1mz - 22./3. + 4./9. * Nf )/(1.-z) 
  + 64./9. * z2*(1.+z2)/(1.+z)/(1.-z) * lnhf1pz
  - ( 64./3. * ln1mz + 4./9. * Nf ) * ((1.+z)*(1.+z) + z3)/(1.+z) 
  - 4./9. * z2 * (25. + 39.*z2)/(1.+z)/(1.-z) * lnz 
  + 2./9. * (33.+70.*z+36.*z2+30.*z3-4.*z4)/(1.+z) ) * DD1(1.,y) 
 + ( - 28./9. * z2 * ( li2(z) - li2(-z) - ln2*lnz )
    + 28./9. * z2 * (2.+5.*z2)/(1.+z)/(1.-z) * lnz2
    - 4./9. * z2 * (9.+23.*z2)/(1.+z)/(1.-z) * lnz * lnhf1pz
    - 4./9. * z2 * (65.+79.*z2)/(1.+z)/(1.-z) * lnz * ln1mz
    + 4./9. * z * (10.+12.*z+3.*z2)/(1.+z) * lnhf1pz
    - 4./9. * z * (2.-28.*z-z2-33.*z3+6.*z4)/(1.+z)/(1.-z) * lnz
    + 8./9. * z * (2.-17.*z-3.*z2-17.*z3+2.*z4)/(1.+z)/(1.-z) * ln1mz
    + 4./27. * z * (25.+8.*z-60.*z2+14.*z3+22.*z4)/(1.+z)/(1.-z)
    + 2./9. * z2 * (19.-23.*z2)/(1.+z)/(1.-z) * Z2 
    + 8./9. * z2 * (1.+z2)/(1.+z)/(1.-z) 
          * ( 8. * ( 2. * lnhf1pz + 3. * ln1mz) * ln1mz 
            - Nf * log(z/(1.-z)) )
     - 8./27. * Nf * z2 * (4.-3.*z+4.*z2)/(1.+z)/(1.-z) ) * DD1(0.,y) ;
//
 temp_mu = lnmu * (
  + 32/3. * ( 
    ( - DD1(0.,1-z) + (z3+z2+2*z+1)/(1+z) ) * DD1(1.,y)
  + ( ( 1/3. * DD1(0.,1-z) - 1/3. * (z3+z2+2*z+1)/(1+z) ) * lnmu
    - 2 * DD1(1.,1-z) + 3/16. * DD1(0.,1-z)
    + 1/6. * z2 * (7+9*z2)/(1+z)/(1-z) * log(z)
    - 2/3. * z2 * (1+z2)/(1+z)/(1-z) * log((1.+z)/2.)
    + (z3+z2+2*z+1)/(1+z) * ( 2 * log(1.-z) - 3/16. ) )
        * DD1(0.,y) )
   // put -ln(y)/(1-y) * DD1(0,1-z) term in "extra" piece...
  + 4/9. * Nf * ( - DD1(0.,1-z) + (z3+z2+2*z+1)/(1+z) ) * DD1(0.,y) );
//
 double C_A = 3.;
 temp_muR = lnmuR * 1/4. * (11/3. * C_A - 2/3. * Nf) * NLO_qbarq_real_soft(y,z);
//
 return real_conv(0.,z) * ( temp + temp_mu ) + temp_muR;
}

// An auxiliary pure ``double-plus'' term, for which no z -> 1 subtraction
// should be required --- but it may improve things to make the
// subtraction:

double qbarq_plus2_A(double y, double z, double Nf, double muFQ){
 double Z2,temp,lnmu,temp_mu;
 Z2 = ZETA2;  lnmu = 2.*log(muFQ);
//
 temp =
 + 16./3. * DD1(0.,1.-z) * DD1(2.,y)
 + ( 64./3. * DD1(1.,1.-z) - ( 22./3. - 4./9. * Nf) * DD1(0.,1.-z) ) * DD1(1.,y) 
 + ( 64./3. * DD1(2.,1.-z) - ( 44./3. - 8./9. * Nf ) * DD1(1.,1.-z)
    + ( - 4./9. * Z2  + 2./3. - 20./27. * Nf ) * DD1(0.,1.-z) ) * DD1(0.,y) ;
//
 temp_mu = 32./3. * lnmu * ( - DD1(0.,1-z) * DD1(1.,y)
  + ( - 2. * DD1(1.,1-z) + ( 1./3. * lnmu + 3./16. - 1./24. * Nf ) * DD1(0.,1-z) )
      * DD1(0.,y) );
//
 return real_conv(0.,1.) * ( temp + temp_mu );
}

// Explicitly y-dependent terms end up here:

double qbarq_real_soft_extra_A(double y, double z, double Nf, double muFQ){
 double ln1mz, temp, lnmu, temp_mu;
 ln1mz = log(1.-z);
 lnmu = 2.*log(muFQ);
 temp =
 + 16./3./(1.-z) * log(y)*log(y)/(1.-y)
 + ( 16./3. * log(1.-y)/y + 64./3. * ln1mz - 22./3. + 4./9. * Nf )
    /(1.-z) * log(y)/(1.-y) ;
 temp_mu = lnmu * (-32/3.) * log(y)/(1-y)/(1-z);
 return real_conv(0.,z) * ( temp + temp_mu );
}

// A remainder term, from "soft", becomes treated as "hard" 
// (no subtraction):

double qbarq_soft_to_hard_A(double y, double z, double Nf, double muFQ){
 double Z2,z2,z3,z4,ln2,lnz,lnz2,ln1mz,lnhf1pz, temp,lnmu,temp_mu;
 Z2 = ZETA2;
 ln2 = log(2.);  lnz = log(z);  lnz2 = lnz*lnz;
 ln1mz = log(1.-z);   lnhf1pz = log((1.+z)/2.);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;
 lnmu = 2.*log(muFQ);
 //
 temp =
 + 16./3. * ( 1./(1.-y)/(1.-z) - (z3+z2+2.*z+1.)/(1.+z) ) * DD1(2.,y)
 + ( ( 16./3. * log(1.-y) + 64./3. * ln1mz - 22./3. + 4./9. * Nf )/(1.-z) 
       * 1./(1.-y)
  + 64./9. * z2*(1.+z2)/(1.+z)/(1.-z) * lnhf1pz
  - ( 64./3. * ln1mz + 4./9. * Nf ) * ((1.+z)*(1.+z) + z3)/(1.+z) 
  - 4./9. * z2 * (25. + 39.*z2)/(1.+z)/(1.-z) * lnz 
  + 2./9. * (33.+70.*z+36.*z2+30.*z3-4.*z4)/(1.+z) ) * DD1(1.,y) 
 + ( - 28./9. * z2 * ( li2(z) - li2(-z) - ln2*lnz )
    + 28./9. * z2 * (2.+5.*z2)/(1.+z)/(1.-z) * lnz2
    - 4./9. * z2 * (9.+23.*z2)/(1.+z)/(1.-z) * lnz * lnhf1pz
    - 4./9. * z2 * (65.+79.*z2)/(1.+z)/(1.-z) * lnz * ln1mz
    + 4./9. * z * (10.+12.*z+3.*z2)/(1.+z) * lnhf1pz
    - 4./9. * z * (2.-28.*z-z2-33.*z3+6.*z4)/(1.+z)/(1.-z) * lnz
    + 8./9. * z * (2.-17.*z-3.*z2-17.*z3+2.*z4)/(1.+z)/(1.-z) * ln1mz
    + 4./27. * z * (25.+8.*z-60.*z2+14.*z3+22.*z4)/(1.+z)/(1.-z)
    + 2./9. * z2 * (19.-23.*z2)/(1.+z)/(1.-z) * Z2 
    + 8./9. * z2 * (1.+z2)/(1.+z)/(1.-z) 
          * ( 8. * ( 2. * lnhf1pz + 3. * ln1mz) * ln1mz 
            - Nf * log(z/(1.-z)) )
     - 8./27. * Nf * z2 * (4.-3.*z+4.*z2)/(1.+z)/(1.-z) ) * DD1(0.,y) ;
//
 temp_mu = lnmu * (
  + 32/3. * ( 
    ( - DD1(0.,1-z) + (z3+z2+2*z+1)/(1+z) ) * DD1(1.,y)
  + ( ( 1/3. * DD1(0.,1-z) - 1/3. * (z3+z2+2*z+1)/(1+z) ) * lnmu
    - 2 * DD1(1.,1-z) + 3/16. * DD1(0.,1-z)
    + 1/6. * z2 * (7+9*z2)/(1+z)/(1-z) * log(z)
    - 2/3. * z2 * (1+z2)/(1+z)/(1-z) * log((1.+z)/2.)
    + (z3+z2+2*z+1)/(1+z) * ( 2 * log(1.-z) - 3/16. ) )
        * DD1(0.,y) 
  - log(y)/(1-y) * DD1(0.,1-z) )
  + 4/9. * Nf * ( - DD1(0.,1-z) + (z3+z2+2*z+1)/(1+z) ) * DD1(0.,y) );
//
 return ( real_conv(y,z) - real_conv(0.,z) ) * ( temp + temp_mu );
}

// A z=1 subtraction term induced by y-dependent terms in 
// qbarq_real_soft_A above:

double qbarq_real_soft_z1_A(double y, double z, double Nf, double muFQ){
 double temp, lnmu, temp_mu;
 lnmu = 2.*log(muFQ);
 temp = + 16./3./(1.-z) * log(y)*log(y)/(1.-y)
   + ( 16./3. * log(1.-y)/y + 64./3. * log(1.-z) - 22./3. + 4./9. * Nf )
    /(1.-z) * log(y)/(1.-y) ;
 temp_mu = lnmu * (-32./3.) * log(y)/(1.-y)/(1.-z);
 return real_conv(0.,1.) * ( temp + temp_mu );
}

// add q-\bar{q} y -> 1-y, i.e. DD1(n,1.-y) terms:

double qbarq_real_soft(double y, double z, double Nf, double muFQ, double muRQ){
  return qbarq_real_soft_A(y,z,Nf,muFQ,muRQ) 
       + qbarq_real_soft_A(1.-y,z,Nf,muFQ,muRQ);
}

// Auxiliary pure ``double-plus'' term, y + (1-y) sum:

double qbarq_plus2(double y, double z, double Nf, double muFQ){
  return qbarq_plus2_A(y,z,Nf,muFQ) + qbarq_plus2_A(1.-y,z,Nf,muFQ);
}
double qbarq_real_soft_extra(double y, double z, double Nf, double muFQ){
  return qbarq_real_soft_extra_A(y,z,Nf,muFQ) 
       + qbarq_real_soft_extra_A(1.-y,z,Nf,muFQ);
}

double qbarq_soft_to_hard(double y, double z, double Nf, double muFQ){
  return qbarq_soft_to_hard_A(y,z,Nf,muFQ) 
       + qbarq_soft_to_hard_A(1.-y,z,Nf,muFQ);
}

// q-\bar{q} 1/y_+ subtraction terms (already given above!):

double qbarq_real_soft_0(double y, double z, double Nf, double muFQ, double muRQ){
 return qbarq_real_soft_A(y,z,Nf,muFQ,muRQ);
}
 
// q-\bar{q} 1/(1-y)_+ subtraction terms:

double qbarq_real_soft_1(double y, double z, double Nf, double muFQ, double muRQ){
  return qbarq_real_soft_0(1.-y,z,Nf,muFQ,muRQ) ;
}

// q-\bar{q} non-delta(y,1-y) 1/(1-z)_+ subtraction terms:

double qbarq_real_soft_z1(double y, double z, double Nf, double muFQ){
  return qbarq_real_soft_z1_A(y,z,Nf,muFQ) 
       + qbarq_real_soft_z1_A(1.-y,z,Nf,muFQ);
}

// NF COEFFICIENTS of qbarq_real_soft terms (may not need these any more):

double qbarq_NF_real_soft_A(double y, double z){
 double z2,z3,temp;
 z2 = z*z;  z3 = z2*z;
 temp = ( 4./9./(1.-z)  // 1/(1-y) = 1 + y/(1-y); 2nd term put in "extra"
        - 4./9. * ((1.+z)*(1.+z) + z3)/(1.+z) ) * DD1(1.,y) 
 + ( - 8./9. * z2 * (1.+z2)/(1.+z)/(1.-z) * log(z/(1.-z)) 
     - 8./27. * z2 * (4.-3.*z+4.*z2)/(1.+z)/(1.-z) ) * DD1(0.,y) ;
 return real_conv(0.,z) * temp;
}

// y/(1-y) term ends up here:

double qbarq_NF_real_soft_extra_A(double y, double z){
 return real_conv(0.,z) *  4./9./(1.-z) * log(y)/(1.-y) ;
}

// A remainder term, from "soft", becomes treated as "hard" 
// (no subtraction):

double qbarq_NF_soft_to_hard_A(double y, double z){
 double z2,z3,temp;
 z2 = z*z;  z3 = z2*z;
 temp = ( 4./9./(1.-z) * 1./(1.-y) 
        - 4./9. * ((1.+z)*(1.+z) + z3)/(1.+z) ) * log(y)/y 
 + ( - 8./9. * z2 * (1.+z2)/(1.+z)/(1.-z) * log(z/(1.-z)) 
     - 8./27. * z2 * (4.-3.*z+4.*z2)/(1.+z)/(1.-z) ) /y ;
 return ( real_conv(y,z) - real_conv(0.,z) ) * temp;
}

// A z=1 subtraction term induced by 1./(1.-y) term in 
// qbarq_NF_real_soft_extra_A above:

double qbarq_NF_real_soft_z1_A(double y, double z){
  return real_conv(0.,1.) * 4./9./(1.-z) * log(y)/(1.-y);
}

// add y -> 1-y terms:

double qbarq_NF_real_soft(double y, double z){
  return qbarq_NF_real_soft_A(y,z) + qbarq_NF_real_soft_A(1.-y,z);
}

double qbarq_NF_real_soft_extra(double y, double z){
  return qbarq_NF_real_soft_extra_A(y,z) 
       + qbarq_NF_real_soft_extra_A(1.-y,z);
}

double qbarq_NF_soft_to_hard(double y, double z){
  return qbarq_NF_soft_to_hard_A(y,z) + qbarq_NF_soft_to_hard_A(1.-y,z);
}

// q-\bar{q} 1/y_+ subtraction terms:

double qbarq_NF_real_soft_0(double y, double z){
 double z2,z3,temp;
 z2 = z*z;  z3 = z2*z;
 temp = ( 4./9./(1.-z) 
        - 4./9. * ((1.+z)*(1.+z) + z3)/(1.+z) ) * DD1(1.,y) 
 + ( - 8./9. * z2 * (1.+z2)/(1.+z)/(1.-z) * log(z/(1.-z))
     - 8./27. * z2 * (4.-3.*z+4.*z2)/(1.+z)/(1.-z) ) * DD1(0.,y) ;
 return real_conv(0.,z) * temp;
}
 
// q-\bar{q} 1/(1-y)_+ subtraction terms:

double qbarq_NF_real_soft_1(double y, double z){
  return qbarq_NF_real_soft_0(1.-y,z) ;
}

// q-\bar{q} non-delta(y,1-y) 1/(1-z)_+ subtraction terms:

double qbarq_NF_real_soft_z1(double y, double z){
  return qbarq_NF_real_soft_z1_A(y,z) + qbarq_NF_real_soft_z1_A(1.-y,z);
}

//====================================================================
// For W production, we have to separate out the "BC" interference terms.
// They are only hard terms, have no factorization scale dependence,
// and have a y -> 1-y symmetry.

double qbarq_BC_1(double y, double z){
  double u,t,r, Z2, ln2, lnz, lnhf1pz, lnu, lnhf1pu, z2,z3,z4, 
  u2,u3,u4,u5,u6,u7,u8, up12,up13, temp;
 u = (z+y*(1.-z))/(1.-y*(1.-z));   t = sqrt(z);   r = sqrt(u);
 Z2 = ZETA2;  ln2 = log(2.);  lnz = log(z);  lnhf1pz = log((1.+z)/2.);
 lnu = log(u);   lnhf1pu = log((1.+u)/2.);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;
 u2 = u*u;  u3 = u2*u;  u4 = u2*u2;  u5 = u3*u2; u6 = u3*u3;
 u7 = u4*u3; u8 = u4*u4;
 up12 = (1.+u)*(1.+u);  up13 = (1.+u)*up12;
//
 temp = 1./9. * z * (1-z) * (
// q^2 terms (mostly):
// J's:
- 4 * u * (1-z*u)*(1-z*u) * J2(y,z)
- 2 * z/u2/(z*up12-4*u2)/(z*up12-4*u2)
* ( 3*z4 + 6*z3*(2*z-1)*u + z2*(4-48*z+19*z2)*u2 
  + 4*z2*(-22*z+15+4*z2)*u3 + z*(-28+9*z3-64*z2+188*z)*u4
  + 2*z*(-92-13*z2+2*z3+42*z)*u5 + (24*z2+72+z4-44*z-8*z3)*u6 )
    * ( J21(y,z) 
      - (1+z) * (1-u*z)/(1+u)/r/(r+t)/(1+t*r)/(1-z)/(1-z)
        * lnz * lnhf1pz
// from q^1 terms:
      + 1/z/(1+u) * ( log((r+t)/(1.+u)) + 2*u/(1-u) * lnz 
    - 1/2. * (1+u)/(1-u) * (1+t/r) * lnu ) )
// polylog's:
- 2 * u/(1+u) * (1-z*u)*(1-z*u) 
   * ( 2 * li2((1.-u)/2.) + li2((1.-u)/(1.+u)) - li2(-u)
     + li2(t*r) - li2((1.-t*r)/2.) 
     - lnz*lnz - 1/2. * lnz * log((1.+u)/u/(1.-z*u))
     + log(abs(1.-u)) * log(u*(1.+u)/2.) 
     + log(abs(1.+u)) * log((1.+u)/2./u/u)
     + 1/2. * lnu*lnu + 1/2. * ln2*ln2   
     - log(1.-t*r) * log(r*(1.+u)/2.)
     - log(1.+t*r) * ( log(1.+u) - 3./2. * lnu - 1./2. * log(1.+t*r) )
     - 3/2. * Z2 )
+ u/(1+u) * (1+z)*(1+z) 
   * ( - 2 * li2(-u) + 2 * li2(-t*r) + lnz * log(1.+u)
     - 1/2. * lnu*lnu )
// pure ln's:
+ 1/2./up12 * ( 1+4*z+z2 - (1+z)*(2-z)*u ) * lnz*lnz
- 1/2./up12 * (2*z - 3*(1+z)*u) * lnu*lnu
- z * u * ( 2+z - z*u ) * lnu * log(1.+t*r)
// q^1:
+ u * (u+4*z*(1+u))/up13 * ( 3+2*z + 2*(5+z)*u + 2*(3-2*z)*u2 - 4*z*u3 )
  * J27(y,z)
- 1/2./up13/u/(z*up12-4) * ( 2*(4-z) + 2*(24+4*z-3*z2)*u
   + (156+17*z-32*z2)*u2 + 4*(46+6*z3-39*z2-22*z)*u3
   + (72-201*z-280*z2+110*z3)*u4 - 2*z*(61+91*z-100*z2)*u5
   - 4*z*(4+6*z-45*z2)*u6 + 8*z2*(1+10*z)*u7 + 14*z3*u8 )
  * log((1.+t*r)*u/(1.+u))
- 1/8./up12/u2/(z*up12-4) * ( 52*z2*(4-z) 
   - 4*z*(72-214*z+75*z2)*u + 4*(60-251*z+343*z2-173*z3)*u2 
   + (4-857*z+1140*z2-796*z3)*u3
   - 2*z*(79-314*z+228*z2)*u4 + z*(47+212*z-104*z2)*u5 )
  * log(z/u)
- 1/2. * (9-14*z+8*z2) * (1+t/r)/(1-u) * lnu
- 1/8. * u*(1-u)/up13/u2/(z*up12-4) * ( - 4*(8+30*z-56*z2+12*z3) 
   + 4*(28-267*z+306*z2-80*z3)*u + (132-937*z+1472*z2-672*z3)*u2 
   - 2*z*(47-340*z+288*z2)*u3 - z*(105-208*z+176*z2)*u4 ) * lnu
+ 1/2. * t/r * (1-u)/u2/up12/(z*up12-4) * ( 6*z2*(4-z) 
  - 12*z*(4-9*z+3*z2)*u - (4+87*z-214*z2+96*z3)*u2 
  - 2*(32+23*z-84*z2+66*z3)*u3 + 3*z*(11+18*z-30*z2)*u4 
  + 4*z*(5+4*z-6*z2)*u5 ) * lnu
// q^0:
+ 1/4./up12/u/(z*up12-4) * ( 2*z*(4-z)*(15+26*z) 
  - 2*(36-37*z-103*z2+87*z3)*u + (76+97*z+2*z2-213*z3)*u2 
  - 2*z*(18+23*z+56*z2)*u3 - z*(19+8*z+21*z2)*u4 )
- 1/2. * t/r /(1+u)/u/(z*up12-4) * ( 26*z*(4-z) - 4*(12-27*z+19*z2)*u 
  + (44+29*z-78*z2)*u2 - 2*(4+5*z+16*z2)*u3 - z*(3+4*z)*u4 ) );
//
 return temp;
}

// u -> 1 limit:

double qbarq_BC_u1(double z){
 double t, Z2, z2,z3,z4, ln2,lnz, tp12, lnhf1pt;
 t = sqrt(z);  ln2 = log(2.);  lnz = log(z); 
 tp12 = (1.+t)*(1.+t);  lnhf1pt = log((1.+t)/2.);
 Z2 = ZETA2, z2 = z*z;  z3 = z2*z;  z4 = z2*z2;  
//
return 1/9. * z * (1-z) * (
- (1-z)*(1-z) * ( 8 * J2_u1(z) - 2 * li2((1.-t)/2.) 
            + lnz * log(1-z) + lnhf1pt*lnhf1pt )
- 2 * z * ( 9 - 14*z + 8*z2 ) * J21_u1(z)
+ (1+z)*(1+z) * li2(z) - 4 * (1+z2) * li2(t)
+ 1/4. * ( 7 - 13*z + 10*z2 ) * lnz*lnz
+ z * (1+z) * ( 9 - 14*z + 8*z2 )/(1-z)/tp12
   * lnz * log(1+z)
- (10*z4+4*z3*t-6*z3-4*z2*t-5*z2+4*t*z+9*z-4*t-2)/(1-z)/tp12 
   * ln2 * lnz
+ ( 3*z2 - 2*z + 3 ) * Z2
//
+ 1/4. * (1+8*z)*(19-4*z) * J27_u1(z) 
+ 1/16. * ( 216*z2 - 120*z + 61 ) * lnz 
- 1/8. * ( 216*z2 - 128*z - 45 ) * lnhf1pt
- 1/8. * ( 143*z2 - 216*t*z + 60*z + 12*t + 1) );
}

// z -> 1 limit:

double qbarq_BC_z1(double y, double z){ 
  double a,a2,a3,a4,a5,a6,a7,a8,y2,y3,y4,y5,y6;
  a = 1.-z;  a2 = a*a;
  a3 = a2*a;  a4 = a2*a2;  a5 = a3*a2;  a6 = a3*a3;  a7 = a4*a3;  a8 = a4*a4;  
  y2 = y*y;  y3 = y2*y;  y4 = y2*y2;  y5 = y3*y2;   y6 = y3*y3;
 return -1/9.*y*(-1+y)*a3
    +a4*7/216.*(-1+2*y)*(-1+2*y)
    +a5*(-1/72.*y+2/27.*y2-13/108.*y3+13/216.*y4-1/144.)
    +a6*(-35/5184.+61/4320.*y+13/12960.*y2-49/1620.*y3+49/3240.*y4)
    +a7*(-103/720.*y5+37/2880.*y-127/25920.+103/2160.*y6+4201/25920.*y4
         -1111/12960.*y3+1/162.*y2);
}

// Full, patched, BC result:

double qbarq_BC(double y, double z){
  // z = 1 patch:
  if (abs(1.-z) < 0.05){ return qbarq_BC_z1(y,z); }
  // u = 1 patch:
  if (abs(y-0.5) < 0.0005/sqrt(1.-z)){ return qbarq_BC_u1(z); }
  // u = z, 1-z patches not needed.
  // z = (2*u/(1+u))^2 patch (average values on either side of strip):
  double eps = 1.0e-07;
  if (abs(y-y_sing(z)) < eps){ 
    return 0.5 * ( qbarq_BC(y_sing(z)-2.*eps,z) 
		 + qbarq_BC(y_sing(z)+2.*eps,z) );
  }
  if (abs(y-(1.-y_sing(z))) < eps){ 
    return 0.5 * ( qbarq_BC(1.-y_sing(z)-2.*eps,z) 
		 + qbarq_BC(1.-y_sing(z)+2.*eps,z) );
  }
  else { return qbarq_BC_1(y,z) + qbarq_BC_1(1.-y,z); }
}

// Final result, including conversion factor:

double qbarq_BC_real_hard(double y, double z){
  return real_conv(y,z) * qbarq_BC(y,z) ;
}

//====================================================================
// The full q-\bar{q} real "hard" term, including conversion factor,
// and adding in all other terms multiplying "lumi_ys",
// as well as muF-dependent terms:

// Here are just the mu-dependent hard terms:

double qbarq_mu_1(double y, double z, double Nf, double muFQ){
  double u,t,r, z2,z3,z4,z5, u2,u3,u4,u5,u6, up12, lnmu, temp;
 u = (z+y*(1.-z))/(1.-y*(1.-z));   t = sqrt(z);   r = sqrt(u);
 z2 = z*z;  z3 = z2*z;  z4 = z2*z2;  z5 = z3*z2;
 u2 = u*u;  u3 = u2*u;  u4 = u2*u2;  u5 = u3*u2; u6 = u3*u3;
 up12 = (1.+u)*(1.+u);
 lnmu = 2.*log(muFQ);
//
 temp = 4./9. * z * (1-z) * lnmu * (
- 1/(1+z)/(u-z)/(1-u*z) * ( 2*z*(3*z2-2*z+3) - (1+z2)*(z2-6*z+1)*u ) 
  * lnmu
+ 2/(1+z)/u/(u-z)/(1-u*z) * ( 2*z2*(1+z) 
   - z*(15+2*z3+19*z2)*u + (1-12*z3+2*z4+5*z2-12*z)*u2 )
   * log(z)
+ 8 * z * (1+z2) * up12/(1+z)/(u-z)/(1-u*z)
   * log((1.+z)/2.)
- 12 * (1-z) * ((1+z)*(1+z)+z3) * up12/z/(1+z)/(u-z)/(1-u*z)
   * log(1.-z)
+ (1-u) * (1+u)/u/(u-z)/(1-u*z) *  ( 4*z - (2+3*z2+z)*u )
   * log(u)
- 8/z/(1+z)/u/up12/(u-z)/(1-u*z) * ( z2*(1+z)*u6
  - (4*z4+5*z2+3+7*z+2*z3)*u5 - (12*z4+9+17*z+17*z2+9*z3)*u4
  + (-5*z2-8*z+z5-9+6*z3-5*z4)*u3 - (5*z4+2*z5+3-3*z-3*z3)*u2
  - z*(-3-4*z2-z3+z4-2*z)*u + z3*(1+z) )
   * log((u-z)/(1.+u))
+ 4/u/up12/(1-u*z)/(u-z) * ( 2*z*u6 - (3*z2+2-3*z)*u5
  - (15*z2+7+3*z3+9*z)*u4 + 2*z*(1+z)*u3 - (15*z+7*z3+3+9*z2)*u2
  - z*(2*z2-3*z+3)*u + 2*z2 )
   * log(r-t)
+ t/r * (1+u) * (1+u*z) * (u+z)/(u-z)/(1-u*z)
   * ( lnmu + 4 * log((r+t)/2./(r-t)) )
+ 1./2./(1+z)/up12 * ( 49+80*z+49*z2 + 2*(4+4*z2-z)*u )
- 4 * t/r * (5+u)/(1+u)
//
- Nf * ( 1 + z2 - 2*z*u )/(1+z)/up12 );
  return temp;
}

double qbarq_mu(double y, double z, double Nf, double muFQ){
  return qbarq_mu_1(y,z,Nf,muFQ) + qbarq_mu_1(1.-y,z,Nf,muFQ);
}


// The hard terms induced for muR <> muF:

double qbarq_muR_hard(double y, double z, double Nf, double muFQ, double muRQ){
  double C_A = 3.;
  return 1/4. * (11/3. * C_A - 2/3. * Nf) * 2. * log(muRQ/muFQ) 
              * ( NLO_qbarq_real(y,z) - NLO_qbarq_real_soft(y,z)
                                      - NLO_qbarq_real_soft(1.-y,z) );
}

//====================================================================
// The full q-\bar{q} real "hard" term, including conversion factor,
// and adding in all other terms multiplying "lumi_ys".
// Now includes all muF-dependence.

double qbarq_real_hard(double y, double z, double Nf, double muFQ, double muRQ){
 return real_conv(y,z) * ( qbarq_no_NF(y,z) + Nf * qbarq_NF(y,z)
			   + qbarq_mu(y,z,Nf,muFQ) )
      + qbarq_muR_hard(y,z,Nf,muFQ,muRQ)
      + qbarq_soft_to_hard(y,z,Nf,muFQ) 
      + qbarq_real_soft(y,z,Nf,muFQ,muRQ) + qbarq_real_soft_extra(y,z,Nf,muFQ)
   // Subtract BC^2 terms --- with a factor of 2 because that is how
   // they entered "resqq_total":
      - 2. * qbarq_BC_real_hard(y,z)
   // Subtract C^2 and C*D terms --- for muF=Q because
   // qbarq_mu(y,z,Nf,muFQ) has already subtracted the muF-dependence
   // of C^2 and C*D !!!
      - qq11_real_hard(y,z,1.) - qq11_real_hard(1.-y,z,1.)
      - qq12_real_hard(y,z);
}
